// ----
// ---- file   : osc_fm2s_macro.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c osc_fm2s_macro.cpp -o osc_fm2s_macro.o
// ---- created: 11Nov2023 18:42:00
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>


#define OVERSAMPLE_FACTOR  16.0f

#define PARAM_OP1_MIX            0
#define PARAM_OP2_MIX            1
#define PARAM_OP1_PHA            2
#define PARAM_OP2_PHA            3
#define PARAM_OP1_DET            4
#define PARAM_OP2_DET            5
#define PARAM_OP2_RATIO          6
#define PARAM_OP2_LEVEL          7
#define NUM_PARAMS               8
static const char *loc_param_names[NUM_PARAMS] = {
   "op1_mix",                 // 0: OP1_MIX
   "op2_mix",                 // 1: OP2_MIX
   "op1_pha",                 // 2: OP1_PHA
   "op2_pha",                 // 3: OP2_PHA
   "op1_det",                 // 4: OP1_DET
   "op2_det",                 // 5: OP2_DET
   "op2_ratio",               // 6: OP2_RATIO
   "op2_level",               // 7: OP2_LEVEL

};
static float loc_param_resets[NUM_PARAMS] = {
   0.5f,                      // 0: OP1_MIX
   0.5f,                      // 1: OP2_MIX
   0.0f,                      // 2: OP1_PHA
   0.0f,                      // 3: OP2_PHA
   0.0f,                      // 4: OP1_DET
   0.0f,                      // 5: OP2_DET
   0.5f,                      // 6: OP2_RATIO
   0.0f,                      // 7: OP2_LEVEL

};

#define MOD_OP1_MIX              0
#define MOD_OP2_MIX              1
#define MOD_OP1_PHA              2
#define MOD_OP2_PHA              3
#define MOD_OP1_DET              4
#define MOD_OP2_DET              5
#define MOD_OP2_RATIO            6
#define MOD_OP2_LEVEL            7
#define NUM_MODS                 8
static const char *loc_mod_names[NUM_MODS] = {
   "op1_mix",      // 0: OP1_MIX
   "op2_mix",      // 1: OP2_MIX
   "op1_pha",      // 2: OP1_PHA
   "op2_pha",      // 3: OP2_PHA
   "op1_det",      // 4: OP1_DET
   "op2_det",      // 5: OP2_DET
   "op2_ratio",    // 6: OP2_RATIO
   "op2_level",    // 7: OP2_LEVEL

};

typedef struct osc_fm2s_macro_info_s {
   st_plugin_info_t base;
} osc_fm2s_macro_info_t;

typedef struct osc_fm2s_macro_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} osc_fm2s_macro_shared_t;

typedef struct osc_fm2s_macro_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];
   float mod_op1_mix_cur;
   float mod_op1_mix_inc;
   float mod_op2_mix_cur;
   float mod_op2_mix_inc;
   float mod_op1_pha_cur;
   float mod_op1_pha_inc;
   float mod_op2_pha_cur;
   float mod_op2_pha_inc;
   float mod_op1_det_cur;
   float mod_op1_det_inc;
   float mod_op2_det_cur;
   float mod_op2_det_inc;
   float mod_op2_ratio_cur;
   float mod_op2_ratio_inc;
   float mod_op2_level_cur;
   float mod_op2_level_inc;

   float tmp1_pos;
   float tmp2_amt;
   float tmp5_pos;
   float tmp6_amt;
   float tmp9_pos;
   float tmp10_amt;
   float tmp13_pos;
   float tmp14_amt;
   float tmp17_pos;
   float tmp18_amt;
   float tmp21_pos;
   float tmp22_amt;
   float tmp25_seq;
   float tmp26_seq;
   float tmp27_seq;
   float tmp28_seq;
   float tmp29_seq;
   float tmp30_seq;
   float tmp31_seq;
   float tmp32_seq;
   float tmp33_seq;
   float tmp34_sin_phase;
   float tmp35_sin_speed;
   float tmp36_freq;
   float tmp37_sin_tmp;
   float tmp38_phase;
   float tmp39_seq;
   float tmp40_seq;
   float tmp41_tri_phase;
   float tmp42_tri_speed;
   float tmp43_freq;
   float tmp44_tri_tmp;
   float tmp45_phase;
   float tmp46_seq;
   float tmp47_seq;
   float tmp48_pul_phase;
   float tmp49_pul_speed;
   float tmp50_freq;
   float tmp51_pul_tmp;
   float tmp52_phase;
   float tmp53_width;
   float tmp54_seq;
   float tmp55_seq;
   float tmp56_saw_phase;
   float tmp57_saw_speed;
   float tmp58_freq;
   float tmp59_saw_tmp;
   float tmp60_phase;
   float tmp61_seq;
   float tmp62_seq;
   float tmp63_sin_phase;
   float tmp64_sin_speed;
   float tmp65_freq;
   float tmp66_sin_tmp;
   float tmp67_phase;
   float tmp68_seq;
   float tmp69_seq;
   float tmp70_seq;
   float tmp71_tri_phase;
   float tmp72_tri_speed;
   float tmp73_freq;
   float tmp74_tri_tmp;
   float tmp75_phase;
   float tmp76_seq;
   float tmp77_seq;
   float tmp78_seq;
   float tmp79_pul_phase;
   float tmp80_pul_speed;
   float tmp81_freq;
   float tmp82_pul_tmp;
   float tmp83_phase;
   float tmp84_seq;
   float tmp85_width;
   float tmp86_seq;
   float tmp87_seq;
   float tmp88_saw_phase;
   float tmp89_saw_speed;
   float tmp90_freq;
   float tmp91_saw_tmp;
   float tmp92_phase;
   float tmp93_seq;
   float tmp94_seq;
   float var_x;
   float var_v_freq_1_sin;
   float var_v_freq_1_tri;
   float var_v_freq_1_pul;
   float var_v_freq_1_saw;
   float var_v_freq;
   float var_v_freq_2_sin;
   float var_v_freq_2_tri;
   float var_v_freq_2_pul;
   float var_v_freq_2_saw;
   float var_v_level_2;
   float var_v_osc_2;

   float macrovar_osc_mix_1_sin;
   float macrovar_osc_mix_1_tri;
   float macrovar_osc_mix_1_pul;
   float macrovar_osc_mix_1_saw;
   float macrovar_osc_pha_1_sin;
   float macrovar_osc_pha_1_tri;
   float macrovar_osc_pha_1_pul;
   float macrovar_osc_pha_1_saw;
   float macrovar_osc_det_1_sin;
   float macrovar_osc_det_1_tri;
   float macrovar_osc_det_1_pul;
   float macrovar_osc_det_1_saw;
   float macrovar_osc_mix_2_sin;
   float macrovar_osc_mix_2_tri;
   float macrovar_osc_mix_2_pul;
   float macrovar_osc_mix_2_saw;
   float macrovar_osc_pha_2_sin;
   float macrovar_osc_pha_2_tri;
   float macrovar_osc_pha_2_pul;
   float macrovar_osc_pha_2_saw;
   float macrovar_osc_det_2_sin;
   float macrovar_osc_det_2_tri;
   float macrovar_osc_det_2_pul;
   float macrovar_osc_det_2_saw;

} osc_fm2s_macro_voice_t;

static const float macrovalues_osc_mix_1[(16 * 4)/*64*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ 1.0f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.0f, 1.0f, 0.0f, 0.0f, 
   /*    3 */ 1.0f, 1.0f, 0.0f, 0.0f, 
   /*    4 */ 0.0f, 0.0f, 1.0f, 0.0f, 
   /*    5 */ 1.0f, 0.0f, 1.0f, 0.0f, 
   /*    6 */ 0.0f, 1.0f, 1.0f, 0.0f, 
   /*    7 */ 1.0f, 1.0f, 1.0f, 0.0f, 
   /*    8 */ 0.0f, 0.0f, 0.0f, 1.0f, 
   /*    9 */ 1.0f, 0.0f, 0.0f, 1.0f, 
   /*   10 */ 0.0f, 1.0f, 0.0f, 1.0f, 
   /*   11 */ 1.0f, 1.0f, 0.0f, 1.0f, 
   /*   12 */ 0.0f, 0.0f, 1.0f, 1.0f, 
   /*   13 */ 1.0f, 0.0f, 1.0f, 1.0f, 
   /*   14 */ 0.0f, 1.0f, 1.0f, 1.0f, 
   /*   15 */ 1.0f, 1.0f, 1.0f, 1.0f, 
};

static const float macrovalues_osc_pha_1[(256 * 4)/*1024*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ 0.75f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.25f, 0.0f, 0.0f, 0.0f, 
   /*    3 */ 0.5f, 0.0f, 0.0f, 0.0f, 
   /*    4 */ 0.0f, 0.75f, 0.0f, 0.0f, 
   /*    5 */ 0.75f, 0.75f, 0.0f, 0.0f, 
   /*    6 */ 0.25f, 0.75f, 0.0f, 0.0f, 
   /*    7 */ 0.5f, 0.75f, 0.0f, 0.0f, 
   /*    8 */ 0.0f, 0.25f, 0.0f, 0.0f, 
   /*    9 */ 0.75f, 0.25f, 0.0f, 0.0f, 
   /*   10 */ 0.25f, 0.25f, 0.0f, 0.0f, 
   /*   11 */ 0.5f, 0.25f, 0.0f, 0.0f, 
   /*   12 */ 0.0f, 0.5f, 0.0f, 0.0f, 
   /*   13 */ 0.75f, 0.5f, 0.0f, 0.0f, 
   /*   14 */ 0.25f, 0.5f, 0.0f, 0.0f, 
   /*   15 */ 0.5f, 0.5f, 0.0f, 0.0f, 
   /*   16 */ 0.0f, 0.0f, 0.75f, 0.0f, 
   /*   17 */ 0.75f, 0.0f, 0.75f, 0.0f, 
   /*   18 */ 0.25f, 0.0f, 0.75f, 0.0f, 
   /*   19 */ 0.5f, 0.0f, 0.75f, 0.0f, 
   /*   20 */ 0.0f, 0.75f, 0.75f, 0.0f, 
   /*   21 */ 0.75f, 0.75f, 0.75f, 0.0f, 
   /*   22 */ 0.25f, 0.75f, 0.75f, 0.0f, 
   /*   23 */ 0.5f, 0.75f, 0.75f, 0.0f, 
   /*   24 */ 0.0f, 0.25f, 0.75f, 0.0f, 
   /*   25 */ 0.75f, 0.25f, 0.75f, 0.0f, 
   /*   26 */ 0.25f, 0.25f, 0.75f, 0.0f, 
   /*   27 */ 0.5f, 0.25f, 0.75f, 0.0f, 
   /*   28 */ 0.0f, 0.5f, 0.75f, 0.0f, 
   /*   29 */ 0.75f, 0.5f, 0.75f, 0.0f, 
   /*   30 */ 0.25f, 0.5f, 0.75f, 0.0f, 
   /*   31 */ 0.5f, 0.5f, 0.75f, 0.0f, 
   /*   32 */ 0.0f, 0.0f, 0.25f, 0.0f, 
   /*   33 */ 0.75f, 0.0f, 0.25f, 0.0f, 
   /*   34 */ 0.25f, 0.0f, 0.25f, 0.0f, 
   /*   35 */ 0.5f, 0.0f, 0.25f, 0.0f, 
   /*   36 */ 0.0f, 0.75f, 0.25f, 0.0f, 
   /*   37 */ 0.75f, 0.75f, 0.25f, 0.0f, 
   /*   38 */ 0.25f, 0.75f, 0.25f, 0.0f, 
   /*   39 */ 0.5f, 0.75f, 0.25f, 0.0f, 
   /*   40 */ 0.0f, 0.25f, 0.25f, 0.0f, 
   /*   41 */ 0.75f, 0.25f, 0.25f, 0.0f, 
   /*   42 */ 0.25f, 0.25f, 0.25f, 0.0f, 
   /*   43 */ 0.5f, 0.25f, 0.25f, 0.0f, 
   /*   44 */ 0.0f, 0.5f, 0.25f, 0.0f, 
   /*   45 */ 0.75f, 0.5f, 0.25f, 0.0f, 
   /*   46 */ 0.25f, 0.5f, 0.25f, 0.0f, 
   /*   47 */ 0.5f, 0.5f, 0.25f, 0.0f, 
   /*   48 */ 0.0f, 0.0f, 0.5f, 0.0f, 
   /*   49 */ 0.75f, 0.0f, 0.5f, 0.0f, 
   /*   50 */ 0.25f, 0.0f, 0.5f, 0.0f, 
   /*   51 */ 0.5f, 0.0f, 0.5f, 0.0f, 
   /*   52 */ 0.0f, 0.75f, 0.5f, 0.0f, 
   /*   53 */ 0.75f, 0.75f, 0.5f, 0.0f, 
   /*   54 */ 0.25f, 0.75f, 0.5f, 0.0f, 
   /*   55 */ 0.5f, 0.75f, 0.5f, 0.0f, 
   /*   56 */ 0.0f, 0.25f, 0.5f, 0.0f, 
   /*   57 */ 0.75f, 0.25f, 0.5f, 0.0f, 
   /*   58 */ 0.25f, 0.25f, 0.5f, 0.0f, 
   /*   59 */ 0.5f, 0.25f, 0.5f, 0.0f, 
   /*   60 */ 0.0f, 0.5f, 0.5f, 0.0f, 
   /*   61 */ 0.75f, 0.5f, 0.5f, 0.0f, 
   /*   62 */ 0.25f, 0.5f, 0.5f, 0.0f, 
   /*   63 */ 0.5f, 0.5f, 0.5f, 0.0f, 
   /*   64 */ 0.0f, 0.0f, 0.0f, 0.75f, 
   /*   65 */ 0.75f, 0.0f, 0.0f, 0.75f, 
   /*   66 */ 0.25f, 0.0f, 0.0f, 0.75f, 
   /*   67 */ 0.5f, 0.0f, 0.0f, 0.75f, 
   /*   68 */ 0.0f, 0.75f, 0.0f, 0.75f, 
   /*   69 */ 0.75f, 0.75f, 0.0f, 0.75f, 
   /*   70 */ 0.25f, 0.75f, 0.0f, 0.75f, 
   /*   71 */ 0.5f, 0.75f, 0.0f, 0.75f, 
   /*   72 */ 0.0f, 0.25f, 0.0f, 0.75f, 
   /*   73 */ 0.75f, 0.25f, 0.0f, 0.75f, 
   /*   74 */ 0.25f, 0.25f, 0.0f, 0.75f, 
   /*   75 */ 0.5f, 0.25f, 0.0f, 0.75f, 
   /*   76 */ 0.0f, 0.5f, 0.0f, 0.75f, 
   /*   77 */ 0.75f, 0.5f, 0.0f, 0.75f, 
   /*   78 */ 0.25f, 0.5f, 0.0f, 0.75f, 
   /*   79 */ 0.5f, 0.5f, 0.0f, 0.75f, 
   /*   80 */ 0.0f, 0.0f, 0.75f, 0.75f, 
   /*   81 */ 0.75f, 0.0f, 0.75f, 0.75f, 
   /*   82 */ 0.25f, 0.0f, 0.75f, 0.75f, 
   /*   83 */ 0.5f, 0.0f, 0.75f, 0.75f, 
   /*   84 */ 0.0f, 0.75f, 0.75f, 0.75f, 
   /*   85 */ 0.75f, 0.75f, 0.75f, 0.75f, 
   /*   86 */ 0.25f, 0.75f, 0.75f, 0.75f, 
   /*   87 */ 0.5f, 0.75f, 0.75f, 0.75f, 
   /*   88 */ 0.0f, 0.25f, 0.75f, 0.75f, 
   /*   89 */ 0.75f, 0.25f, 0.75f, 0.75f, 
   /*   90 */ 0.25f, 0.25f, 0.75f, 0.75f, 
   /*   91 */ 0.5f, 0.25f, 0.75f, 0.75f, 
   /*   92 */ 0.0f, 0.5f, 0.75f, 0.75f, 
   /*   93 */ 0.75f, 0.5f, 0.75f, 0.75f, 
   /*   94 */ 0.25f, 0.5f, 0.75f, 0.75f, 
   /*   95 */ 0.5f, 0.5f, 0.75f, 0.75f, 
   /*   96 */ 0.0f, 0.0f, 0.25f, 0.75f, 
   /*   97 */ 0.75f, 0.0f, 0.25f, 0.75f, 
   /*   98 */ 0.25f, 0.0f, 0.25f, 0.75f, 
   /*   99 */ 0.5f, 0.0f, 0.25f, 0.75f, 
   /*  100 */ 0.0f, 0.75f, 0.25f, 0.75f, 
   /*  101 */ 0.75f, 0.75f, 0.25f, 0.75f, 
   /*  102 */ 0.25f, 0.75f, 0.25f, 0.75f, 
   /*  103 */ 0.5f, 0.75f, 0.25f, 0.75f, 
   /*  104 */ 0.0f, 0.25f, 0.25f, 0.75f, 
   /*  105 */ 0.75f, 0.25f, 0.25f, 0.75f, 
   /*  106 */ 0.25f, 0.25f, 0.25f, 0.75f, 
   /*  107 */ 0.5f, 0.25f, 0.25f, 0.75f, 
   /*  108 */ 0.0f, 0.5f, 0.25f, 0.75f, 
   /*  109 */ 0.75f, 0.5f, 0.25f, 0.75f, 
   /*  110 */ 0.25f, 0.5f, 0.25f, 0.75f, 
   /*  111 */ 0.5f, 0.5f, 0.25f, 0.75f, 
   /*  112 */ 0.0f, 0.0f, 0.5f, 0.75f, 
   /*  113 */ 0.75f, 0.0f, 0.5f, 0.75f, 
   /*  114 */ 0.25f, 0.0f, 0.5f, 0.75f, 
   /*  115 */ 0.5f, 0.0f, 0.5f, 0.75f, 
   /*  116 */ 0.0f, 0.75f, 0.5f, 0.75f, 
   /*  117 */ 0.75f, 0.75f, 0.5f, 0.75f, 
   /*  118 */ 0.25f, 0.75f, 0.5f, 0.75f, 
   /*  119 */ 0.5f, 0.75f, 0.5f, 0.75f, 
   /*  120 */ 0.0f, 0.25f, 0.5f, 0.75f, 
   /*  121 */ 0.75f, 0.25f, 0.5f, 0.75f, 
   /*  122 */ 0.25f, 0.25f, 0.5f, 0.75f, 
   /*  123 */ 0.5f, 0.25f, 0.5f, 0.75f, 
   /*  124 */ 0.0f, 0.5f, 0.5f, 0.75f, 
   /*  125 */ 0.75f, 0.5f, 0.5f, 0.75f, 
   /*  126 */ 0.25f, 0.5f, 0.5f, 0.75f, 
   /*  127 */ 0.5f, 0.5f, 0.5f, 0.75f, 
   /*  128 */ 0.0f, 0.0f, 0.0f, 0.25f, 
   /*  129 */ 0.75f, 0.0f, 0.0f, 0.25f, 
   /*  130 */ 0.25f, 0.0f, 0.0f, 0.25f, 
   /*  131 */ 0.5f, 0.0f, 0.0f, 0.25f, 
   /*  132 */ 0.0f, 0.75f, 0.0f, 0.25f, 
   /*  133 */ 0.75f, 0.75f, 0.0f, 0.25f, 
   /*  134 */ 0.25f, 0.75f, 0.0f, 0.25f, 
   /*  135 */ 0.5f, 0.75f, 0.0f, 0.25f, 
   /*  136 */ 0.0f, 0.25f, 0.0f, 0.25f, 
   /*  137 */ 0.75f, 0.25f, 0.0f, 0.25f, 
   /*  138 */ 0.25f, 0.25f, 0.0f, 0.25f, 
   /*  139 */ 0.5f, 0.25f, 0.0f, 0.25f, 
   /*  140 */ 0.0f, 0.5f, 0.0f, 0.25f, 
   /*  141 */ 0.75f, 0.5f, 0.0f, 0.25f, 
   /*  142 */ 0.25f, 0.5f, 0.0f, 0.25f, 
   /*  143 */ 0.5f, 0.5f, 0.0f, 0.25f, 
   /*  144 */ 0.0f, 0.0f, 0.75f, 0.25f, 
   /*  145 */ 0.75f, 0.0f, 0.75f, 0.25f, 
   /*  146 */ 0.25f, 0.0f, 0.75f, 0.25f, 
   /*  147 */ 0.5f, 0.0f, 0.75f, 0.25f, 
   /*  148 */ 0.0f, 0.75f, 0.75f, 0.25f, 
   /*  149 */ 0.75f, 0.75f, 0.75f, 0.25f, 
   /*  150 */ 0.25f, 0.75f, 0.75f, 0.25f, 
   /*  151 */ 0.5f, 0.75f, 0.75f, 0.25f, 
   /*  152 */ 0.0f, 0.25f, 0.75f, 0.25f, 
   /*  153 */ 0.75f, 0.25f, 0.75f, 0.25f, 
   /*  154 */ 0.25f, 0.25f, 0.75f, 0.25f, 
   /*  155 */ 0.5f, 0.25f, 0.75f, 0.25f, 
   /*  156 */ 0.0f, 0.5f, 0.75f, 0.25f, 
   /*  157 */ 0.75f, 0.5f, 0.75f, 0.25f, 
   /*  158 */ 0.25f, 0.5f, 0.75f, 0.25f, 
   /*  159 */ 0.5f, 0.5f, 0.75f, 0.25f, 
   /*  160 */ 0.0f, 0.0f, 0.25f, 0.25f, 
   /*  161 */ 0.75f, 0.0f, 0.25f, 0.25f, 
   /*  162 */ 0.25f, 0.0f, 0.25f, 0.25f, 
   /*  163 */ 0.5f, 0.0f, 0.25f, 0.25f, 
   /*  164 */ 0.0f, 0.75f, 0.25f, 0.25f, 
   /*  165 */ 0.75f, 0.75f, 0.25f, 0.25f, 
   /*  166 */ 0.25f, 0.75f, 0.25f, 0.25f, 
   /*  167 */ 0.5f, 0.75f, 0.25f, 0.25f, 
   /*  168 */ 0.0f, 0.25f, 0.25f, 0.25f, 
   /*  169 */ 0.75f, 0.25f, 0.25f, 0.25f, 
   /*  170 */ 0.25f, 0.25f, 0.25f, 0.25f, 
   /*  171 */ 0.5f, 0.25f, 0.25f, 0.25f, 
   /*  172 */ 0.0f, 0.5f, 0.25f, 0.25f, 
   /*  173 */ 0.75f, 0.5f, 0.25f, 0.25f, 
   /*  174 */ 0.25f, 0.5f, 0.25f, 0.25f, 
   /*  175 */ 0.5f, 0.5f, 0.25f, 0.25f, 
   /*  176 */ 0.0f, 0.0f, 0.5f, 0.25f, 
   /*  177 */ 0.75f, 0.0f, 0.5f, 0.25f, 
   /*  178 */ 0.25f, 0.0f, 0.5f, 0.25f, 
   /*  179 */ 0.5f, 0.0f, 0.5f, 0.25f, 
   /*  180 */ 0.0f, 0.75f, 0.5f, 0.25f, 
   /*  181 */ 0.75f, 0.75f, 0.5f, 0.25f, 
   /*  182 */ 0.25f, 0.75f, 0.5f, 0.25f, 
   /*  183 */ 0.5f, 0.75f, 0.5f, 0.25f, 
   /*  184 */ 0.0f, 0.25f, 0.5f, 0.25f, 
   /*  185 */ 0.75f, 0.25f, 0.5f, 0.25f, 
   /*  186 */ 0.25f, 0.25f, 0.5f, 0.25f, 
   /*  187 */ 0.5f, 0.25f, 0.5f, 0.25f, 
   /*  188 */ 0.0f, 0.5f, 0.5f, 0.25f, 
   /*  189 */ 0.75f, 0.5f, 0.5f, 0.25f, 
   /*  190 */ 0.25f, 0.5f, 0.5f, 0.25f, 
   /*  191 */ 0.5f, 0.5f, 0.5f, 0.25f, 
   /*  192 */ 0.0f, 0.0f, 0.0f, 0.5f, 
   /*  193 */ 0.75f, 0.0f, 0.0f, 0.5f, 
   /*  194 */ 0.25f, 0.0f, 0.0f, 0.5f, 
   /*  195 */ 0.5f, 0.0f, 0.0f, 0.5f, 
   /*  196 */ 0.0f, 0.75f, 0.0f, 0.5f, 
   /*  197 */ 0.75f, 0.75f, 0.0f, 0.5f, 
   /*  198 */ 0.25f, 0.75f, 0.0f, 0.5f, 
   /*  199 */ 0.5f, 0.75f, 0.0f, 0.5f, 
   /*  200 */ 0.0f, 0.25f, 0.0f, 0.5f, 
   /*  201 */ 0.75f, 0.25f, 0.0f, 0.5f, 
   /*  202 */ 0.25f, 0.25f, 0.0f, 0.5f, 
   /*  203 */ 0.5f, 0.25f, 0.0f, 0.5f, 
   /*  204 */ 0.0f, 0.5f, 0.0f, 0.5f, 
   /*  205 */ 0.75f, 0.5f, 0.0f, 0.5f, 
   /*  206 */ 0.25f, 0.5f, 0.0f, 0.5f, 
   /*  207 */ 0.5f, 0.5f, 0.0f, 0.5f, 
   /*  208 */ 0.0f, 0.0f, 0.75f, 0.5f, 
   /*  209 */ 0.75f, 0.0f, 0.75f, 0.5f, 
   /*  210 */ 0.25f, 0.0f, 0.75f, 0.5f, 
   /*  211 */ 0.5f, 0.0f, 0.75f, 0.5f, 
   /*  212 */ 0.0f, 0.75f, 0.75f, 0.5f, 
   /*  213 */ 0.75f, 0.75f, 0.75f, 0.5f, 
   /*  214 */ 0.25f, 0.75f, 0.75f, 0.5f, 
   /*  215 */ 0.5f, 0.75f, 0.75f, 0.5f, 
   /*  216 */ 0.0f, 0.25f, 0.75f, 0.5f, 
   /*  217 */ 0.75f, 0.25f, 0.75f, 0.5f, 
   /*  218 */ 0.25f, 0.25f, 0.75f, 0.5f, 
   /*  219 */ 0.5f, 0.25f, 0.75f, 0.5f, 
   /*  220 */ 0.0f, 0.5f, 0.75f, 0.5f, 
   /*  221 */ 0.75f, 0.5f, 0.75f, 0.5f, 
   /*  222 */ 0.25f, 0.5f, 0.75f, 0.5f, 
   /*  223 */ 0.5f, 0.5f, 0.75f, 0.5f, 
   /*  224 */ 0.0f, 0.0f, 0.25f, 0.5f, 
   /*  225 */ 0.75f, 0.0f, 0.25f, 0.5f, 
   /*  226 */ 0.25f, 0.0f, 0.25f, 0.5f, 
   /*  227 */ 0.5f, 0.0f, 0.25f, 0.5f, 
   /*  228 */ 0.0f, 0.75f, 0.25f, 0.5f, 
   /*  229 */ 0.75f, 0.75f, 0.25f, 0.5f, 
   /*  230 */ 0.25f, 0.75f, 0.25f, 0.5f, 
   /*  231 */ 0.5f, 0.75f, 0.25f, 0.5f, 
   /*  232 */ 0.0f, 0.25f, 0.25f, 0.5f, 
   /*  233 */ 0.75f, 0.25f, 0.25f, 0.5f, 
   /*  234 */ 0.25f, 0.25f, 0.25f, 0.5f, 
   /*  235 */ 0.5f, 0.25f, 0.25f, 0.5f, 
   /*  236 */ 0.0f, 0.5f, 0.25f, 0.5f, 
   /*  237 */ 0.75f, 0.5f, 0.25f, 0.5f, 
   /*  238 */ 0.25f, 0.5f, 0.25f, 0.5f, 
   /*  239 */ 0.5f, 0.5f, 0.25f, 0.5f, 
   /*  240 */ 0.0f, 0.0f, 0.5f, 0.5f, 
   /*  241 */ 0.75f, 0.0f, 0.5f, 0.5f, 
   /*  242 */ 0.25f, 0.0f, 0.5f, 0.5f, 
   /*  243 */ 0.5f, 0.0f, 0.5f, 0.5f, 
   /*  244 */ 0.0f, 0.75f, 0.5f, 0.5f, 
   /*  245 */ 0.75f, 0.75f, 0.5f, 0.5f, 
   /*  246 */ 0.25f, 0.75f, 0.5f, 0.5f, 
   /*  247 */ 0.5f, 0.75f, 0.5f, 0.5f, 
   /*  248 */ 0.0f, 0.25f, 0.5f, 0.5f, 
   /*  249 */ 0.75f, 0.25f, 0.5f, 0.5f, 
   /*  250 */ 0.25f, 0.25f, 0.5f, 0.5f, 
   /*  251 */ 0.5f, 0.25f, 0.5f, 0.5f, 
   /*  252 */ 0.0f, 0.5f, 0.5f, 0.5f, 
   /*  253 */ 0.75f, 0.5f, 0.5f, 0.5f, 
   /*  254 */ 0.25f, 0.5f, 0.5f, 0.5f, 
   /*  255 */ 0.5f, 0.5f, 0.5f, 0.5f, 
};

static const float macrovalues_osc_det_1[(81 * 4)/*324*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ -0.005f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.005f, 0.0f, 0.0f, 0.0f, 
   /*    3 */ 0.0f, -0.005f, 0.0f, 0.0f, 
   /*    4 */ -0.005f, -0.005f, 0.0f, 0.0f, 
   /*    5 */ 0.005f, -0.005f, 0.0f, 0.0f, 
   /*    6 */ 0.0f, 0.005f, 0.0f, 0.0f, 
   /*    7 */ -0.005f, 0.005f, 0.0f, 0.0f, 
   /*    8 */ 0.005f, 0.005f, 0.0f, 0.0f, 
   /*    9 */ 0.0f, 0.0f, -0.005f, 0.0f, 
   /*   10 */ -0.005f, 0.0f, -0.005f, 0.0f, 
   /*   11 */ 0.005f, 0.0f, -0.005f, 0.0f, 
   /*   12 */ 0.0f, -0.005f, -0.005f, 0.0f, 
   /*   13 */ -0.005f, -0.005f, -0.005f, 0.0f, 
   /*   14 */ 0.005f, -0.005f, -0.005f, 0.0f, 
   /*   15 */ 0.0f, 0.005f, -0.005f, 0.0f, 
   /*   16 */ -0.005f, 0.005f, -0.005f, 0.0f, 
   /*   17 */ 0.005f, 0.005f, -0.005f, 0.0f, 
   /*   18 */ 0.0f, 0.0f, 0.005f, 0.0f, 
   /*   19 */ -0.005f, 0.0f, 0.005f, 0.0f, 
   /*   20 */ 0.005f, 0.0f, 0.005f, 0.0f, 
   /*   21 */ 0.0f, -0.005f, 0.005f, 0.0f, 
   /*   22 */ -0.005f, -0.005f, 0.005f, 0.0f, 
   /*   23 */ 0.005f, -0.005f, 0.005f, 0.0f, 
   /*   24 */ 0.0f, 0.005f, 0.005f, 0.0f, 
   /*   25 */ -0.005f, 0.005f, 0.005f, 0.0f, 
   /*   26 */ 0.005f, 0.005f, 0.005f, 0.0f, 
   /*   27 */ 0.0f, 0.0f, 0.0f, -0.005f, 
   /*   28 */ -0.005f, 0.0f, 0.0f, -0.005f, 
   /*   29 */ 0.005f, 0.0f, 0.0f, -0.005f, 
   /*   30 */ 0.0f, -0.005f, 0.0f, -0.005f, 
   /*   31 */ -0.005f, -0.005f, 0.0f, -0.005f, 
   /*   32 */ 0.005f, -0.005f, 0.0f, -0.005f, 
   /*   33 */ 0.0f, 0.005f, 0.0f, -0.005f, 
   /*   34 */ -0.005f, 0.005f, 0.0f, -0.005f, 
   /*   35 */ 0.005f, 0.005f, 0.0f, -0.005f, 
   /*   36 */ 0.0f, 0.0f, -0.005f, -0.005f, 
   /*   37 */ -0.005f, 0.0f, -0.005f, -0.005f, 
   /*   38 */ 0.005f, 0.0f, -0.005f, -0.005f, 
   /*   39 */ 0.0f, -0.005f, -0.005f, -0.005f, 
   /*   40 */ -0.005f, -0.005f, -0.005f, -0.005f, 
   /*   41 */ 0.005f, -0.005f, -0.005f, -0.005f, 
   /*   42 */ 0.0f, 0.005f, -0.005f, -0.005f, 
   /*   43 */ -0.005f, 0.005f, -0.005f, -0.005f, 
   /*   44 */ 0.005f, 0.005f, -0.005f, -0.005f, 
   /*   45 */ 0.0f, 0.0f, 0.005f, -0.005f, 
   /*   46 */ -0.005f, 0.0f, 0.005f, -0.005f, 
   /*   47 */ 0.005f, 0.0f, 0.005f, -0.005f, 
   /*   48 */ 0.0f, -0.005f, 0.005f, -0.005f, 
   /*   49 */ -0.005f, -0.005f, 0.005f, -0.005f, 
   /*   50 */ 0.005f, -0.005f, 0.005f, -0.005f, 
   /*   51 */ 0.0f, 0.005f, 0.005f, -0.005f, 
   /*   52 */ -0.005f, 0.005f, 0.005f, -0.005f, 
   /*   53 */ 0.005f, 0.005f, 0.005f, -0.005f, 
   /*   54 */ 0.0f, 0.0f, 0.0f, 0.005f, 
   /*   55 */ -0.005f, 0.0f, 0.0f, 0.005f, 
   /*   56 */ 0.005f, 0.0f, 0.0f, 0.005f, 
   /*   57 */ 0.0f, -0.005f, 0.0f, 0.005f, 
   /*   58 */ -0.005f, -0.005f, 0.0f, 0.005f, 
   /*   59 */ 0.005f, -0.005f, 0.0f, 0.005f, 
   /*   60 */ 0.0f, 0.005f, 0.0f, 0.005f, 
   /*   61 */ -0.005f, 0.005f, 0.0f, 0.005f, 
   /*   62 */ 0.005f, 0.005f, 0.0f, 0.005f, 
   /*   63 */ 0.0f, 0.0f, -0.005f, 0.005f, 
   /*   64 */ -0.005f, 0.0f, -0.005f, 0.005f, 
   /*   65 */ 0.005f, 0.0f, -0.005f, 0.005f, 
   /*   66 */ 0.0f, -0.005f, -0.005f, 0.005f, 
   /*   67 */ -0.005f, -0.005f, -0.005f, 0.005f, 
   /*   68 */ 0.005f, -0.005f, -0.005f, 0.005f, 
   /*   69 */ 0.0f, 0.005f, -0.005f, 0.005f, 
   /*   70 */ -0.005f, 0.005f, -0.005f, 0.005f, 
   /*   71 */ 0.005f, 0.005f, -0.005f, 0.005f, 
   /*   72 */ 0.0f, 0.0f, 0.005f, 0.005f, 
   /*   73 */ -0.005f, 0.0f, 0.005f, 0.005f, 
   /*   74 */ 0.005f, 0.0f, 0.005f, 0.005f, 
   /*   75 */ 0.0f, -0.005f, 0.005f, 0.005f, 
   /*   76 */ -0.005f, -0.005f, 0.005f, 0.005f, 
   /*   77 */ 0.005f, -0.005f, 0.005f, 0.005f, 
   /*   78 */ 0.0f, 0.005f, 0.005f, 0.005f, 
   /*   79 */ -0.005f, 0.005f, 0.005f, 0.005f, 
   /*   80 */ 0.005f, 0.005f, 0.005f, 0.005f, 
};

static const float macrovalues_osc_mix_2[(16 * 4)/*64*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ 1.0f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.0f, 1.0f, 0.0f, 0.0f, 
   /*    3 */ 1.0f, 1.0f, 0.0f, 0.0f, 
   /*    4 */ 0.0f, 0.0f, 1.0f, 0.0f, 
   /*    5 */ 1.0f, 0.0f, 1.0f, 0.0f, 
   /*    6 */ 0.0f, 1.0f, 1.0f, 0.0f, 
   /*    7 */ 1.0f, 1.0f, 1.0f, 0.0f, 
   /*    8 */ 0.0f, 0.0f, 0.0f, 1.0f, 
   /*    9 */ 1.0f, 0.0f, 0.0f, 1.0f, 
   /*   10 */ 0.0f, 1.0f, 0.0f, 1.0f, 
   /*   11 */ 1.0f, 1.0f, 0.0f, 1.0f, 
   /*   12 */ 0.0f, 0.0f, 1.0f, 1.0f, 
   /*   13 */ 1.0f, 0.0f, 1.0f, 1.0f, 
   /*   14 */ 0.0f, 1.0f, 1.0f, 1.0f, 
   /*   15 */ 1.0f, 1.0f, 1.0f, 1.0f, 
};

static const float macrovalues_osc_pha_2[(256 * 4)/*1024*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ 0.75f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.25f, 0.0f, 0.0f, 0.0f, 
   /*    3 */ 0.5f, 0.0f, 0.0f, 0.0f, 
   /*    4 */ 0.0f, 0.75f, 0.0f, 0.0f, 
   /*    5 */ 0.75f, 0.75f, 0.0f, 0.0f, 
   /*    6 */ 0.25f, 0.75f, 0.0f, 0.0f, 
   /*    7 */ 0.5f, 0.75f, 0.0f, 0.0f, 
   /*    8 */ 0.0f, 0.25f, 0.0f, 0.0f, 
   /*    9 */ 0.75f, 0.25f, 0.0f, 0.0f, 
   /*   10 */ 0.25f, 0.25f, 0.0f, 0.0f, 
   /*   11 */ 0.5f, 0.25f, 0.0f, 0.0f, 
   /*   12 */ 0.0f, 0.5f, 0.0f, 0.0f, 
   /*   13 */ 0.75f, 0.5f, 0.0f, 0.0f, 
   /*   14 */ 0.25f, 0.5f, 0.0f, 0.0f, 
   /*   15 */ 0.5f, 0.5f, 0.0f, 0.0f, 
   /*   16 */ 0.0f, 0.0f, 0.75f, 0.0f, 
   /*   17 */ 0.75f, 0.0f, 0.75f, 0.0f, 
   /*   18 */ 0.25f, 0.0f, 0.75f, 0.0f, 
   /*   19 */ 0.5f, 0.0f, 0.75f, 0.0f, 
   /*   20 */ 0.0f, 0.75f, 0.75f, 0.0f, 
   /*   21 */ 0.75f, 0.75f, 0.75f, 0.0f, 
   /*   22 */ 0.25f, 0.75f, 0.75f, 0.0f, 
   /*   23 */ 0.5f, 0.75f, 0.75f, 0.0f, 
   /*   24 */ 0.0f, 0.25f, 0.75f, 0.0f, 
   /*   25 */ 0.75f, 0.25f, 0.75f, 0.0f, 
   /*   26 */ 0.25f, 0.25f, 0.75f, 0.0f, 
   /*   27 */ 0.5f, 0.25f, 0.75f, 0.0f, 
   /*   28 */ 0.0f, 0.5f, 0.75f, 0.0f, 
   /*   29 */ 0.75f, 0.5f, 0.75f, 0.0f, 
   /*   30 */ 0.25f, 0.5f, 0.75f, 0.0f, 
   /*   31 */ 0.5f, 0.5f, 0.75f, 0.0f, 
   /*   32 */ 0.0f, 0.0f, 0.25f, 0.0f, 
   /*   33 */ 0.75f, 0.0f, 0.25f, 0.0f, 
   /*   34 */ 0.25f, 0.0f, 0.25f, 0.0f, 
   /*   35 */ 0.5f, 0.0f, 0.25f, 0.0f, 
   /*   36 */ 0.0f, 0.75f, 0.25f, 0.0f, 
   /*   37 */ 0.75f, 0.75f, 0.25f, 0.0f, 
   /*   38 */ 0.25f, 0.75f, 0.25f, 0.0f, 
   /*   39 */ 0.5f, 0.75f, 0.25f, 0.0f, 
   /*   40 */ 0.0f, 0.25f, 0.25f, 0.0f, 
   /*   41 */ 0.75f, 0.25f, 0.25f, 0.0f, 
   /*   42 */ 0.25f, 0.25f, 0.25f, 0.0f, 
   /*   43 */ 0.5f, 0.25f, 0.25f, 0.0f, 
   /*   44 */ 0.0f, 0.5f, 0.25f, 0.0f, 
   /*   45 */ 0.75f, 0.5f, 0.25f, 0.0f, 
   /*   46 */ 0.25f, 0.5f, 0.25f, 0.0f, 
   /*   47 */ 0.5f, 0.5f, 0.25f, 0.0f, 
   /*   48 */ 0.0f, 0.0f, 0.5f, 0.0f, 
   /*   49 */ 0.75f, 0.0f, 0.5f, 0.0f, 
   /*   50 */ 0.25f, 0.0f, 0.5f, 0.0f, 
   /*   51 */ 0.5f, 0.0f, 0.5f, 0.0f, 
   /*   52 */ 0.0f, 0.75f, 0.5f, 0.0f, 
   /*   53 */ 0.75f, 0.75f, 0.5f, 0.0f, 
   /*   54 */ 0.25f, 0.75f, 0.5f, 0.0f, 
   /*   55 */ 0.5f, 0.75f, 0.5f, 0.0f, 
   /*   56 */ 0.0f, 0.25f, 0.5f, 0.0f, 
   /*   57 */ 0.75f, 0.25f, 0.5f, 0.0f, 
   /*   58 */ 0.25f, 0.25f, 0.5f, 0.0f, 
   /*   59 */ 0.5f, 0.25f, 0.5f, 0.0f, 
   /*   60 */ 0.0f, 0.5f, 0.5f, 0.0f, 
   /*   61 */ 0.75f, 0.5f, 0.5f, 0.0f, 
   /*   62 */ 0.25f, 0.5f, 0.5f, 0.0f, 
   /*   63 */ 0.5f, 0.5f, 0.5f, 0.0f, 
   /*   64 */ 0.0f, 0.0f, 0.0f, 0.75f, 
   /*   65 */ 0.75f, 0.0f, 0.0f, 0.75f, 
   /*   66 */ 0.25f, 0.0f, 0.0f, 0.75f, 
   /*   67 */ 0.5f, 0.0f, 0.0f, 0.75f, 
   /*   68 */ 0.0f, 0.75f, 0.0f, 0.75f, 
   /*   69 */ 0.75f, 0.75f, 0.0f, 0.75f, 
   /*   70 */ 0.25f, 0.75f, 0.0f, 0.75f, 
   /*   71 */ 0.5f, 0.75f, 0.0f, 0.75f, 
   /*   72 */ 0.0f, 0.25f, 0.0f, 0.75f, 
   /*   73 */ 0.75f, 0.25f, 0.0f, 0.75f, 
   /*   74 */ 0.25f, 0.25f, 0.0f, 0.75f, 
   /*   75 */ 0.5f, 0.25f, 0.0f, 0.75f, 
   /*   76 */ 0.0f, 0.5f, 0.0f, 0.75f, 
   /*   77 */ 0.75f, 0.5f, 0.0f, 0.75f, 
   /*   78 */ 0.25f, 0.5f, 0.0f, 0.75f, 
   /*   79 */ 0.5f, 0.5f, 0.0f, 0.75f, 
   /*   80 */ 0.0f, 0.0f, 0.75f, 0.75f, 
   /*   81 */ 0.75f, 0.0f, 0.75f, 0.75f, 
   /*   82 */ 0.25f, 0.0f, 0.75f, 0.75f, 
   /*   83 */ 0.5f, 0.0f, 0.75f, 0.75f, 
   /*   84 */ 0.0f, 0.75f, 0.75f, 0.75f, 
   /*   85 */ 0.75f, 0.75f, 0.75f, 0.75f, 
   /*   86 */ 0.25f, 0.75f, 0.75f, 0.75f, 
   /*   87 */ 0.5f, 0.75f, 0.75f, 0.75f, 
   /*   88 */ 0.0f, 0.25f, 0.75f, 0.75f, 
   /*   89 */ 0.75f, 0.25f, 0.75f, 0.75f, 
   /*   90 */ 0.25f, 0.25f, 0.75f, 0.75f, 
   /*   91 */ 0.5f, 0.25f, 0.75f, 0.75f, 
   /*   92 */ 0.0f, 0.5f, 0.75f, 0.75f, 
   /*   93 */ 0.75f, 0.5f, 0.75f, 0.75f, 
   /*   94 */ 0.25f, 0.5f, 0.75f, 0.75f, 
   /*   95 */ 0.5f, 0.5f, 0.75f, 0.75f, 
   /*   96 */ 0.0f, 0.0f, 0.25f, 0.75f, 
   /*   97 */ 0.75f, 0.0f, 0.25f, 0.75f, 
   /*   98 */ 0.25f, 0.0f, 0.25f, 0.75f, 
   /*   99 */ 0.5f, 0.0f, 0.25f, 0.75f, 
   /*  100 */ 0.0f, 0.75f, 0.25f, 0.75f, 
   /*  101 */ 0.75f, 0.75f, 0.25f, 0.75f, 
   /*  102 */ 0.25f, 0.75f, 0.25f, 0.75f, 
   /*  103 */ 0.5f, 0.75f, 0.25f, 0.75f, 
   /*  104 */ 0.0f, 0.25f, 0.25f, 0.75f, 
   /*  105 */ 0.75f, 0.25f, 0.25f, 0.75f, 
   /*  106 */ 0.25f, 0.25f, 0.25f, 0.75f, 
   /*  107 */ 0.5f, 0.25f, 0.25f, 0.75f, 
   /*  108 */ 0.0f, 0.5f, 0.25f, 0.75f, 
   /*  109 */ 0.75f, 0.5f, 0.25f, 0.75f, 
   /*  110 */ 0.25f, 0.5f, 0.25f, 0.75f, 
   /*  111 */ 0.5f, 0.5f, 0.25f, 0.75f, 
   /*  112 */ 0.0f, 0.0f, 0.5f, 0.75f, 
   /*  113 */ 0.75f, 0.0f, 0.5f, 0.75f, 
   /*  114 */ 0.25f, 0.0f, 0.5f, 0.75f, 
   /*  115 */ 0.5f, 0.0f, 0.5f, 0.75f, 
   /*  116 */ 0.0f, 0.75f, 0.5f, 0.75f, 
   /*  117 */ 0.75f, 0.75f, 0.5f, 0.75f, 
   /*  118 */ 0.25f, 0.75f, 0.5f, 0.75f, 
   /*  119 */ 0.5f, 0.75f, 0.5f, 0.75f, 
   /*  120 */ 0.0f, 0.25f, 0.5f, 0.75f, 
   /*  121 */ 0.75f, 0.25f, 0.5f, 0.75f, 
   /*  122 */ 0.25f, 0.25f, 0.5f, 0.75f, 
   /*  123 */ 0.5f, 0.25f, 0.5f, 0.75f, 
   /*  124 */ 0.0f, 0.5f, 0.5f, 0.75f, 
   /*  125 */ 0.75f, 0.5f, 0.5f, 0.75f, 
   /*  126 */ 0.25f, 0.5f, 0.5f, 0.75f, 
   /*  127 */ 0.5f, 0.5f, 0.5f, 0.75f, 
   /*  128 */ 0.0f, 0.0f, 0.0f, 0.25f, 
   /*  129 */ 0.75f, 0.0f, 0.0f, 0.25f, 
   /*  130 */ 0.25f, 0.0f, 0.0f, 0.25f, 
   /*  131 */ 0.5f, 0.0f, 0.0f, 0.25f, 
   /*  132 */ 0.0f, 0.75f, 0.0f, 0.25f, 
   /*  133 */ 0.75f, 0.75f, 0.0f, 0.25f, 
   /*  134 */ 0.25f, 0.75f, 0.0f, 0.25f, 
   /*  135 */ 0.5f, 0.75f, 0.0f, 0.25f, 
   /*  136 */ 0.0f, 0.25f, 0.0f, 0.25f, 
   /*  137 */ 0.75f, 0.25f, 0.0f, 0.25f, 
   /*  138 */ 0.25f, 0.25f, 0.0f, 0.25f, 
   /*  139 */ 0.5f, 0.25f, 0.0f, 0.25f, 
   /*  140 */ 0.0f, 0.5f, 0.0f, 0.25f, 
   /*  141 */ 0.75f, 0.5f, 0.0f, 0.25f, 
   /*  142 */ 0.25f, 0.5f, 0.0f, 0.25f, 
   /*  143 */ 0.5f, 0.5f, 0.0f, 0.25f, 
   /*  144 */ 0.0f, 0.0f, 0.75f, 0.25f, 
   /*  145 */ 0.75f, 0.0f, 0.75f, 0.25f, 
   /*  146 */ 0.25f, 0.0f, 0.75f, 0.25f, 
   /*  147 */ 0.5f, 0.0f, 0.75f, 0.25f, 
   /*  148 */ 0.0f, 0.75f, 0.75f, 0.25f, 
   /*  149 */ 0.75f, 0.75f, 0.75f, 0.25f, 
   /*  150 */ 0.25f, 0.75f, 0.75f, 0.25f, 
   /*  151 */ 0.5f, 0.75f, 0.75f, 0.25f, 
   /*  152 */ 0.0f, 0.25f, 0.75f, 0.25f, 
   /*  153 */ 0.75f, 0.25f, 0.75f, 0.25f, 
   /*  154 */ 0.25f, 0.25f, 0.75f, 0.25f, 
   /*  155 */ 0.5f, 0.25f, 0.75f, 0.25f, 
   /*  156 */ 0.0f, 0.5f, 0.75f, 0.25f, 
   /*  157 */ 0.75f, 0.5f, 0.75f, 0.25f, 
   /*  158 */ 0.25f, 0.5f, 0.75f, 0.25f, 
   /*  159 */ 0.5f, 0.5f, 0.75f, 0.25f, 
   /*  160 */ 0.0f, 0.0f, 0.25f, 0.25f, 
   /*  161 */ 0.75f, 0.0f, 0.25f, 0.25f, 
   /*  162 */ 0.25f, 0.0f, 0.25f, 0.25f, 
   /*  163 */ 0.5f, 0.0f, 0.25f, 0.25f, 
   /*  164 */ 0.0f, 0.75f, 0.25f, 0.25f, 
   /*  165 */ 0.75f, 0.75f, 0.25f, 0.25f, 
   /*  166 */ 0.25f, 0.75f, 0.25f, 0.25f, 
   /*  167 */ 0.5f, 0.75f, 0.25f, 0.25f, 
   /*  168 */ 0.0f, 0.25f, 0.25f, 0.25f, 
   /*  169 */ 0.75f, 0.25f, 0.25f, 0.25f, 
   /*  170 */ 0.25f, 0.25f, 0.25f, 0.25f, 
   /*  171 */ 0.5f, 0.25f, 0.25f, 0.25f, 
   /*  172 */ 0.0f, 0.5f, 0.25f, 0.25f, 
   /*  173 */ 0.75f, 0.5f, 0.25f, 0.25f, 
   /*  174 */ 0.25f, 0.5f, 0.25f, 0.25f, 
   /*  175 */ 0.5f, 0.5f, 0.25f, 0.25f, 
   /*  176 */ 0.0f, 0.0f, 0.5f, 0.25f, 
   /*  177 */ 0.75f, 0.0f, 0.5f, 0.25f, 
   /*  178 */ 0.25f, 0.0f, 0.5f, 0.25f, 
   /*  179 */ 0.5f, 0.0f, 0.5f, 0.25f, 
   /*  180 */ 0.0f, 0.75f, 0.5f, 0.25f, 
   /*  181 */ 0.75f, 0.75f, 0.5f, 0.25f, 
   /*  182 */ 0.25f, 0.75f, 0.5f, 0.25f, 
   /*  183 */ 0.5f, 0.75f, 0.5f, 0.25f, 
   /*  184 */ 0.0f, 0.25f, 0.5f, 0.25f, 
   /*  185 */ 0.75f, 0.25f, 0.5f, 0.25f, 
   /*  186 */ 0.25f, 0.25f, 0.5f, 0.25f, 
   /*  187 */ 0.5f, 0.25f, 0.5f, 0.25f, 
   /*  188 */ 0.0f, 0.5f, 0.5f, 0.25f, 
   /*  189 */ 0.75f, 0.5f, 0.5f, 0.25f, 
   /*  190 */ 0.25f, 0.5f, 0.5f, 0.25f, 
   /*  191 */ 0.5f, 0.5f, 0.5f, 0.25f, 
   /*  192 */ 0.0f, 0.0f, 0.0f, 0.5f, 
   /*  193 */ 0.75f, 0.0f, 0.0f, 0.5f, 
   /*  194 */ 0.25f, 0.0f, 0.0f, 0.5f, 
   /*  195 */ 0.5f, 0.0f, 0.0f, 0.5f, 
   /*  196 */ 0.0f, 0.75f, 0.0f, 0.5f, 
   /*  197 */ 0.75f, 0.75f, 0.0f, 0.5f, 
   /*  198 */ 0.25f, 0.75f, 0.0f, 0.5f, 
   /*  199 */ 0.5f, 0.75f, 0.0f, 0.5f, 
   /*  200 */ 0.0f, 0.25f, 0.0f, 0.5f, 
   /*  201 */ 0.75f, 0.25f, 0.0f, 0.5f, 
   /*  202 */ 0.25f, 0.25f, 0.0f, 0.5f, 
   /*  203 */ 0.5f, 0.25f, 0.0f, 0.5f, 
   /*  204 */ 0.0f, 0.5f, 0.0f, 0.5f, 
   /*  205 */ 0.75f, 0.5f, 0.0f, 0.5f, 
   /*  206 */ 0.25f, 0.5f, 0.0f, 0.5f, 
   /*  207 */ 0.5f, 0.5f, 0.0f, 0.5f, 
   /*  208 */ 0.0f, 0.0f, 0.75f, 0.5f, 
   /*  209 */ 0.75f, 0.0f, 0.75f, 0.5f, 
   /*  210 */ 0.25f, 0.0f, 0.75f, 0.5f, 
   /*  211 */ 0.5f, 0.0f, 0.75f, 0.5f, 
   /*  212 */ 0.0f, 0.75f, 0.75f, 0.5f, 
   /*  213 */ 0.75f, 0.75f, 0.75f, 0.5f, 
   /*  214 */ 0.25f, 0.75f, 0.75f, 0.5f, 
   /*  215 */ 0.5f, 0.75f, 0.75f, 0.5f, 
   /*  216 */ 0.0f, 0.25f, 0.75f, 0.5f, 
   /*  217 */ 0.75f, 0.25f, 0.75f, 0.5f, 
   /*  218 */ 0.25f, 0.25f, 0.75f, 0.5f, 
   /*  219 */ 0.5f, 0.25f, 0.75f, 0.5f, 
   /*  220 */ 0.0f, 0.5f, 0.75f, 0.5f, 
   /*  221 */ 0.75f, 0.5f, 0.75f, 0.5f, 
   /*  222 */ 0.25f, 0.5f, 0.75f, 0.5f, 
   /*  223 */ 0.5f, 0.5f, 0.75f, 0.5f, 
   /*  224 */ 0.0f, 0.0f, 0.25f, 0.5f, 
   /*  225 */ 0.75f, 0.0f, 0.25f, 0.5f, 
   /*  226 */ 0.25f, 0.0f, 0.25f, 0.5f, 
   /*  227 */ 0.5f, 0.0f, 0.25f, 0.5f, 
   /*  228 */ 0.0f, 0.75f, 0.25f, 0.5f, 
   /*  229 */ 0.75f, 0.75f, 0.25f, 0.5f, 
   /*  230 */ 0.25f, 0.75f, 0.25f, 0.5f, 
   /*  231 */ 0.5f, 0.75f, 0.25f, 0.5f, 
   /*  232 */ 0.0f, 0.25f, 0.25f, 0.5f, 
   /*  233 */ 0.75f, 0.25f, 0.25f, 0.5f, 
   /*  234 */ 0.25f, 0.25f, 0.25f, 0.5f, 
   /*  235 */ 0.5f, 0.25f, 0.25f, 0.5f, 
   /*  236 */ 0.0f, 0.5f, 0.25f, 0.5f, 
   /*  237 */ 0.75f, 0.5f, 0.25f, 0.5f, 
   /*  238 */ 0.25f, 0.5f, 0.25f, 0.5f, 
   /*  239 */ 0.5f, 0.5f, 0.25f, 0.5f, 
   /*  240 */ 0.0f, 0.0f, 0.5f, 0.5f, 
   /*  241 */ 0.75f, 0.0f, 0.5f, 0.5f, 
   /*  242 */ 0.25f, 0.0f, 0.5f, 0.5f, 
   /*  243 */ 0.5f, 0.0f, 0.5f, 0.5f, 
   /*  244 */ 0.0f, 0.75f, 0.5f, 0.5f, 
   /*  245 */ 0.75f, 0.75f, 0.5f, 0.5f, 
   /*  246 */ 0.25f, 0.75f, 0.5f, 0.5f, 
   /*  247 */ 0.5f, 0.75f, 0.5f, 0.5f, 
   /*  248 */ 0.0f, 0.25f, 0.5f, 0.5f, 
   /*  249 */ 0.75f, 0.25f, 0.5f, 0.5f, 
   /*  250 */ 0.25f, 0.25f, 0.5f, 0.5f, 
   /*  251 */ 0.5f, 0.25f, 0.5f, 0.5f, 
   /*  252 */ 0.0f, 0.5f, 0.5f, 0.5f, 
   /*  253 */ 0.75f, 0.5f, 0.5f, 0.5f, 
   /*  254 */ 0.25f, 0.5f, 0.5f, 0.5f, 
   /*  255 */ 0.5f, 0.5f, 0.5f, 0.5f, 
};

static const float macrovalues_osc_det_2[(81 * 4)/*324*/] = {
   /*    0 */ 0.0f, 0.0f, 0.0f, 0.0f, 
   /*    1 */ -0.02f, 0.0f, 0.0f, 0.0f, 
   /*    2 */ 0.02f, 0.0f, 0.0f, 0.0f, 
   /*    3 */ 0.0f, -0.02f, 0.0f, 0.0f, 
   /*    4 */ -0.02f, -0.02f, 0.0f, 0.0f, 
   /*    5 */ 0.02f, -0.02f, 0.0f, 0.0f, 
   /*    6 */ 0.0f, 0.02f, 0.0f, 0.0f, 
   /*    7 */ -0.02f, 0.02f, 0.0f, 0.0f, 
   /*    8 */ 0.02f, 0.02f, 0.0f, 0.0f, 
   /*    9 */ 0.0f, 0.0f, -0.02f, 0.0f, 
   /*   10 */ -0.02f, 0.0f, -0.02f, 0.0f, 
   /*   11 */ 0.02f, 0.0f, -0.02f, 0.0f, 
   /*   12 */ 0.0f, -0.02f, -0.02f, 0.0f, 
   /*   13 */ -0.02f, -0.02f, -0.02f, 0.0f, 
   /*   14 */ 0.02f, -0.02f, -0.02f, 0.0f, 
   /*   15 */ 0.0f, 0.02f, -0.02f, 0.0f, 
   /*   16 */ -0.02f, 0.02f, -0.02f, 0.0f, 
   /*   17 */ 0.02f, 0.02f, -0.02f, 0.0f, 
   /*   18 */ 0.0f, 0.0f, 0.02f, 0.0f, 
   /*   19 */ -0.02f, 0.0f, 0.02f, 0.0f, 
   /*   20 */ 0.02f, 0.0f, 0.02f, 0.0f, 
   /*   21 */ 0.0f, -0.02f, 0.02f, 0.0f, 
   /*   22 */ -0.02f, -0.02f, 0.02f, 0.0f, 
   /*   23 */ 0.02f, -0.02f, 0.02f, 0.0f, 
   /*   24 */ 0.0f, 0.02f, 0.02f, 0.0f, 
   /*   25 */ -0.02f, 0.02f, 0.02f, 0.0f, 
   /*   26 */ 0.02f, 0.02f, 0.02f, 0.0f, 
   /*   27 */ 0.0f, 0.0f, 0.0f, -0.02f, 
   /*   28 */ -0.02f, 0.0f, 0.0f, -0.02f, 
   /*   29 */ 0.02f, 0.0f, 0.0f, -0.02f, 
   /*   30 */ 0.0f, -0.02f, 0.0f, -0.02f, 
   /*   31 */ -0.02f, -0.02f, 0.0f, -0.02f, 
   /*   32 */ 0.02f, -0.02f, 0.0f, -0.02f, 
   /*   33 */ 0.0f, 0.02f, 0.0f, -0.02f, 
   /*   34 */ -0.02f, 0.02f, 0.0f, -0.02f, 
   /*   35 */ 0.02f, 0.02f, 0.0f, -0.02f, 
   /*   36 */ 0.0f, 0.0f, -0.02f, -0.02f, 
   /*   37 */ -0.02f, 0.0f, -0.02f, -0.02f, 
   /*   38 */ 0.02f, 0.0f, -0.02f, -0.02f, 
   /*   39 */ 0.0f, -0.02f, -0.02f, -0.02f, 
   /*   40 */ -0.02f, -0.02f, -0.02f, -0.02f, 
   /*   41 */ 0.02f, -0.02f, -0.02f, -0.02f, 
   /*   42 */ 0.0f, 0.02f, -0.02f, -0.02f, 
   /*   43 */ -0.02f, 0.02f, -0.02f, -0.02f, 
   /*   44 */ 0.02f, 0.02f, -0.02f, -0.02f, 
   /*   45 */ 0.0f, 0.0f, 0.02f, -0.02f, 
   /*   46 */ -0.02f, 0.0f, 0.02f, -0.02f, 
   /*   47 */ 0.02f, 0.0f, 0.02f, -0.02f, 
   /*   48 */ 0.0f, -0.02f, 0.02f, -0.02f, 
   /*   49 */ -0.02f, -0.02f, 0.02f, -0.02f, 
   /*   50 */ 0.02f, -0.02f, 0.02f, -0.02f, 
   /*   51 */ 0.0f, 0.02f, 0.02f, -0.02f, 
   /*   52 */ -0.02f, 0.02f, 0.02f, -0.02f, 
   /*   53 */ 0.02f, 0.02f, 0.02f, -0.02f, 
   /*   54 */ 0.0f, 0.0f, 0.0f, 0.02f, 
   /*   55 */ -0.02f, 0.0f, 0.0f, 0.02f, 
   /*   56 */ 0.02f, 0.0f, 0.0f, 0.02f, 
   /*   57 */ 0.0f, -0.02f, 0.0f, 0.02f, 
   /*   58 */ -0.02f, -0.02f, 0.0f, 0.02f, 
   /*   59 */ 0.02f, -0.02f, 0.0f, 0.02f, 
   /*   60 */ 0.0f, 0.02f, 0.0f, 0.02f, 
   /*   61 */ -0.02f, 0.02f, 0.0f, 0.02f, 
   /*   62 */ 0.02f, 0.02f, 0.0f, 0.02f, 
   /*   63 */ 0.0f, 0.0f, -0.02f, 0.02f, 
   /*   64 */ -0.02f, 0.0f, -0.02f, 0.02f, 
   /*   65 */ 0.02f, 0.0f, -0.02f, 0.02f, 
   /*   66 */ 0.0f, -0.02f, -0.02f, 0.02f, 
   /*   67 */ -0.02f, -0.02f, -0.02f, 0.02f, 
   /*   68 */ 0.02f, -0.02f, -0.02f, 0.02f, 
   /*   69 */ 0.0f, 0.02f, -0.02f, 0.02f, 
   /*   70 */ -0.02f, 0.02f, -0.02f, 0.02f, 
   /*   71 */ 0.02f, 0.02f, -0.02f, 0.02f, 
   /*   72 */ 0.0f, 0.0f, 0.02f, 0.02f, 
   /*   73 */ -0.02f, 0.0f, 0.02f, 0.02f, 
   /*   74 */ 0.02f, 0.0f, 0.02f, 0.02f, 
   /*   75 */ 0.0f, -0.02f, 0.02f, 0.02f, 
   /*   76 */ -0.02f, -0.02f, 0.02f, 0.02f, 
   /*   77 */ 0.02f, -0.02f, 0.02f, 0.02f, 
   /*   78 */ 0.0f, 0.02f, 0.02f, 0.02f, 
   /*   79 */ -0.02f, 0.02f, 0.02f, 0.02f, 
   /*   80 */ 0.02f, 0.02f, 0.02f, 0.02f, 
};

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }

#define USE_CYCLE_SINE_TBL  defined
static float cycle_sine_tbl_f[16384];

static float loc_bipolar_to_scale(const float _t, const float _div, const float _mul) {
   // t (-1..1) => /_div .. *_mul
   
   float s;

   if(_t < 0.0f)
   {
      s = (1.0f / _div);
      s = 1.0f + (s - 1.0f) * -_t;
      if(s < 0.0f)
         s = 0.0f;
   }
   else
   {
      s = _mul;
      s = 1.0f + (s - 1.0f) * _t;
   }
   
   return s;
}

static void loc_prepare(st_plugin_voice_t *_voice);

void loc_prepare(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm2s_macro_shared_t);

   float out = 0.0f;
   // -------- lane "prepare" modIdx=0
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op1_mix" dstVar=voice->tmp1_pos
   voice->tmp1_pos = voice->mod_op1_mix_cur;
   voice->tmp1_pos = ffrac_s(voice->tmp1_pos) * 16;
   voice->tmp2_amt = ffrac_s(voice->tmp1_pos);
   int tmp3_idx;
   tmp3_idx = int(voice->tmp1_pos) * 4;
   int tmp4_idx_n;
   tmp4_idx_n = (tmp3_idx + 4) & 63;
   voice->macrovar_osc_mix_1_sin = mathLerpf(macrovalues_osc_mix_1[tmp3_idx + 0], macrovalues_osc_mix_1[tmp4_idx_n + 0], voice->tmp2_amt);
   voice->macrovar_osc_mix_1_tri = mathLerpf(macrovalues_osc_mix_1[tmp3_idx + 1], macrovalues_osc_mix_1[tmp4_idx_n + 1], voice->tmp2_amt);
   voice->macrovar_osc_mix_1_pul = mathLerpf(macrovalues_osc_mix_1[tmp3_idx + 2], macrovalues_osc_mix_1[tmp4_idx_n + 2], voice->tmp2_amt);
   voice->macrovar_osc_mix_1_saw = mathLerpf(macrovalues_osc_mix_1[tmp3_idx + 3], macrovalues_osc_mix_1[tmp4_idx_n + 3], voice->tmp2_amt);
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op1_pha" dstVar=voice->tmp5_pos
   voice->tmp5_pos = voice->mod_op1_pha_cur;
   voice->tmp5_pos = ffrac_s(voice->tmp5_pos) * 256;
   voice->tmp6_amt = ffrac_s(voice->tmp5_pos);
   int tmp7_idx;
   tmp7_idx = int(voice->tmp5_pos) * 4;
   int tmp8_idx_n;
   tmp8_idx_n = (tmp7_idx + 4) & 1023;
   voice->macrovar_osc_pha_1_sin = mathLerpf(macrovalues_osc_pha_1[tmp7_idx + 0], macrovalues_osc_pha_1[tmp8_idx_n + 0], voice->tmp6_amt);
   voice->macrovar_osc_pha_1_tri = mathLerpf(macrovalues_osc_pha_1[tmp7_idx + 1], macrovalues_osc_pha_1[tmp8_idx_n + 1], voice->tmp6_amt);
   voice->macrovar_osc_pha_1_pul = mathLerpf(macrovalues_osc_pha_1[tmp7_idx + 2], macrovalues_osc_pha_1[tmp8_idx_n + 2], voice->tmp6_amt);
   voice->macrovar_osc_pha_1_saw = mathLerpf(macrovalues_osc_pha_1[tmp7_idx + 3], macrovalues_osc_pha_1[tmp8_idx_n + 3], voice->tmp6_amt);
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op1_det" dstVar=voice->tmp9_pos
   voice->tmp9_pos = voice->mod_op1_det_cur;
   voice->tmp9_pos = ffrac_s(voice->tmp9_pos) * 81;
   voice->tmp10_amt = ffrac_s(voice->tmp9_pos);
   int tmp11_idx;
   tmp11_idx = int(voice->tmp9_pos) * 4;
   int tmp12_idx_n;
   tmp12_idx_n = (tmp11_idx + 4) % 324;
   voice->macrovar_osc_det_1_sin = mathLerpf(macrovalues_osc_det_1[tmp11_idx + 0], macrovalues_osc_det_1[tmp12_idx_n + 0], voice->tmp10_amt);
   voice->macrovar_osc_det_1_tri = mathLerpf(macrovalues_osc_det_1[tmp11_idx + 1], macrovalues_osc_det_1[tmp12_idx_n + 1], voice->tmp10_amt);
   voice->macrovar_osc_det_1_pul = mathLerpf(macrovalues_osc_det_1[tmp11_idx + 2], macrovalues_osc_det_1[tmp12_idx_n + 2], voice->tmp10_amt);
   voice->macrovar_osc_det_1_saw = mathLerpf(macrovalues_osc_det_1[tmp11_idx + 3], macrovalues_osc_det_1[tmp12_idx_n + 3], voice->tmp10_amt);
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op2_mix" dstVar=voice->tmp13_pos
   voice->tmp13_pos = voice->mod_op2_mix_cur;
   voice->tmp13_pos = ffrac_s(voice->tmp13_pos) * 16;
   voice->tmp14_amt = ffrac_s(voice->tmp13_pos);
   int tmp15_idx;
   tmp15_idx = int(voice->tmp13_pos) * 4;
   int tmp16_idx_n;
   tmp16_idx_n = (tmp15_idx + 4) & 63;
   voice->macrovar_osc_mix_2_sin = mathLerpf(macrovalues_osc_mix_2[tmp15_idx + 0], macrovalues_osc_mix_2[tmp16_idx_n + 0], voice->tmp14_amt);
   voice->macrovar_osc_mix_2_tri = mathLerpf(macrovalues_osc_mix_2[tmp15_idx + 1], macrovalues_osc_mix_2[tmp16_idx_n + 1], voice->tmp14_amt);
   voice->macrovar_osc_mix_2_pul = mathLerpf(macrovalues_osc_mix_2[tmp15_idx + 2], macrovalues_osc_mix_2[tmp16_idx_n + 2], voice->tmp14_amt);
   voice->macrovar_osc_mix_2_saw = mathLerpf(macrovalues_osc_mix_2[tmp15_idx + 3], macrovalues_osc_mix_2[tmp16_idx_n + 3], voice->tmp14_amt);
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op2_pha" dstVar=voice->tmp17_pos
   voice->tmp17_pos = voice->mod_op2_pha_cur;
   voice->tmp17_pos = ffrac_s(voice->tmp17_pos) * 256;
   voice->tmp18_amt = ffrac_s(voice->tmp17_pos);
   int tmp19_idx;
   tmp19_idx = int(voice->tmp17_pos) * 4;
   int tmp20_idx_n;
   tmp20_idx_n = (tmp19_idx + 4) & 1023;
   voice->macrovar_osc_pha_2_sin = mathLerpf(macrovalues_osc_pha_2[tmp19_idx + 0], macrovalues_osc_pha_2[tmp20_idx_n + 0], voice->tmp18_amt);
   voice->macrovar_osc_pha_2_tri = mathLerpf(macrovalues_osc_pha_2[tmp19_idx + 1], macrovalues_osc_pha_2[tmp20_idx_n + 1], voice->tmp18_amt);
   voice->macrovar_osc_pha_2_pul = mathLerpf(macrovalues_osc_pha_2[tmp19_idx + 2], macrovalues_osc_pha_2[tmp20_idx_n + 2], voice->tmp18_amt);
   voice->macrovar_osc_pha_2_saw = mathLerpf(macrovalues_osc_pha_2[tmp19_idx + 3], macrovalues_osc_pha_2[tmp20_idx_n + 3], voice->tmp18_amt);
   
   // -- mod="mac" dstVar=out
   
   // ---- mod="mac" input "pos" seq 1/1
   
   // -- mod="$m_op2_det" dstVar=voice->tmp21_pos
   voice->tmp21_pos = voice->mod_op2_det_cur;
   voice->tmp21_pos = ffrac_s(voice->tmp21_pos) * 81;
   voice->tmp22_amt = ffrac_s(voice->tmp21_pos);
   int tmp23_idx;
   tmp23_idx = int(voice->tmp21_pos) * 4;
   int tmp24_idx_n;
   tmp24_idx_n = (tmp23_idx + 4) % 324;
   voice->macrovar_osc_det_2_sin = mathLerpf(macrovalues_osc_det_2[tmp23_idx + 0], macrovalues_osc_det_2[tmp24_idx_n + 0], voice->tmp22_amt);
   voice->macrovar_osc_det_2_tri = mathLerpf(macrovalues_osc_det_2[tmp23_idx + 1], macrovalues_osc_det_2[tmp24_idx_n + 1], voice->tmp22_amt);
   voice->macrovar_osc_det_2_pul = mathLerpf(macrovalues_osc_det_2[tmp23_idx + 2], macrovalues_osc_det_2[tmp24_idx_n + 2], voice->tmp22_amt);
   voice->macrovar_osc_det_2_saw = mathLerpf(macrovalues_osc_det_2[tmp23_idx + 3], macrovalues_osc_det_2[tmp24_idx_n + 3], voice->tmp22_amt);
   
   // -- mod="1" dstVar=out
   out = 1.0f;
   
   // -- mod="sto v_freq" dstVar=out
   voice->var_v_freq = out;
   
   // -- mod="osc_det_1.sin" dstVar=out
   voice->tmp25_seq = voice->macrovar_osc_det_1_sin;
   out += voice->tmp25_seq;
   
   // -- mod="sto v_freq_1_sin" dstVar=out
   voice->var_v_freq_1_sin = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_1.tri" dstVar=out
   voice->tmp26_seq = voice->macrovar_osc_det_1_tri;
   out += voice->tmp26_seq;
   
   // -- mod="sto v_freq_1_tri" dstVar=out
   voice->var_v_freq_1_tri = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_1.pul" dstVar=out
   voice->tmp27_seq = voice->macrovar_osc_det_1_pul;
   out += voice->tmp27_seq;
   
   // -- mod="sto v_freq_1_pul" dstVar=out
   voice->var_v_freq_1_pul = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_1.saw" dstVar=out
   voice->tmp28_seq = voice->macrovar_osc_det_1_saw;
   out += voice->tmp28_seq;
   
   // -- mod="sto v_freq_1_saw" dstVar=out
   voice->var_v_freq_1_saw = out;
   
   // -- mod="$m_op2_ratio" dstVar=out
   out = voice->mod_op2_ratio_cur;
   
   // -- mod="fma" dstVar=out
   out = (out * 2.0f) + -1.0f;
   
   // -- mod="bts" dstVar=out
   out = loc_bipolar_to_scale(out, 4096.0f, 4.0f);
   
   // -- mod="pow" dstVar=out
   out = out * out * out;
   
   // -- mod="qua" dstVar=out
   out = ((int)(out * 100.0f) / 100.0f);
   
   // -- mod="sto v_freq" dstVar=out
   voice->var_v_freq = out;
   
   // -- mod="osc_det_2.sin" dstVar=out
   voice->tmp29_seq = voice->macrovar_osc_det_2_sin;
   out += voice->tmp29_seq;
   
   // -- mod="sto v_freq_2_sin" dstVar=out
   voice->var_v_freq_2_sin = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_2.tri" dstVar=out
   voice->tmp30_seq = voice->macrovar_osc_det_2_tri;
   out += voice->tmp30_seq;
   
   // -- mod="sto v_freq_2_tri" dstVar=out
   voice->var_v_freq_2_tri = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_2.pul" dstVar=out
   voice->tmp31_seq = voice->macrovar_osc_det_2_pul;
   out += voice->tmp31_seq;
   
   // -- mod="sto v_freq_2_pul" dstVar=out
   voice->var_v_freq_2_pul = out;
   
   // -- mod="$v_freq" dstVar=out
   out = voice->var_v_freq;
   
   // -- mod="osc_det_2.saw" dstVar=out
   voice->tmp32_seq = voice->macrovar_osc_det_2_saw;
   out += voice->tmp32_seq;
   
   // -- mod="sto v_freq_2_saw" dstVar=out
   voice->var_v_freq_2_saw = out;
} /* end prepare */

static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(osc_fm2s_macro_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(osc_fm2s_macro_shared_t);
   shared->params[_paramIdx] = _value;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm2s_macro_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR


      voice->tmp34_sin_phase = 0.0f;
      voice->tmp41_tri_phase = 0.0f;
      voice->tmp48_pul_phase = 0.0f;
      voice->tmp56_saw_phase = 0.0f;
      voice->tmp63_sin_phase = 0.0f;
      voice->tmp71_tri_phase = 0.0f;
      voice->tmp79_pul_phase = 0.0f;
      voice->tmp88_saw_phase = 0.0f;

      voice->var_x = 0.0f;
      voice->var_v_freq_1_sin = 0.0f;
      voice->var_v_freq_1_tri = 0.0f;
      voice->var_v_freq_1_pul = 0.0f;
      voice->var_v_freq_1_saw = 0.0f;
      voice->var_v_freq = 0.0f;
      voice->var_v_freq_2_sin = 0.0f;
      voice->var_v_freq_2_tri = 0.0f;
      voice->var_v_freq_2_pul = 0.0f;
      voice->var_v_freq_2_saw = 0.0f;
      voice->var_v_level_2 = 0.0f;
      voice->var_v_osc_2 = 0.0f;
      voice->macrovar_osc_mix_1_sin = 0;
      voice->macrovar_osc_mix_1_tri = 0;
      voice->macrovar_osc_mix_1_pul = 0;
      voice->macrovar_osc_mix_1_saw = 0;
      voice->macrovar_osc_pha_1_sin = 0;
      voice->macrovar_osc_pha_1_tri = 0;
      voice->macrovar_osc_pha_1_pul = 0;
      voice->macrovar_osc_pha_1_saw = 0;
      voice->macrovar_osc_det_1_sin = 0;
      voice->macrovar_osc_det_1_tri = 0;
      voice->macrovar_osc_det_1_pul = 0;
      voice->macrovar_osc_det_1_saw = 0;
      voice->macrovar_osc_mix_2_sin = 0;
      voice->macrovar_osc_mix_2_tri = 0;
      voice->macrovar_osc_mix_2_pul = 0;
      voice->macrovar_osc_mix_2_saw = 0;
      voice->macrovar_osc_pha_2_sin = 0;
      voice->macrovar_osc_pha_2_tri = 0;
      voice->macrovar_osc_pha_2_pul = 0;
      voice->macrovar_osc_pha_2_saw = 0;
      voice->macrovar_osc_det_2_sin = 0;
      voice->macrovar_osc_det_2_tri = 0;
      voice->macrovar_osc_det_2_pul = 0;
      voice->macrovar_osc_det_2_saw = 0;


   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm2s_macro_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR

   float modop1_mix      = shared->params[PARAM_OP1_MIX     ]                       + voice->mods[MOD_OP1_MIX      ];
   float modop2_mix      = shared->params[PARAM_OP2_MIX     ]                       + voice->mods[MOD_OP2_MIX      ];
   float modop1_pha      = shared->params[PARAM_OP1_PHA     ]                       + voice->mods[MOD_OP1_PHA      ];
   float modop2_pha      = shared->params[PARAM_OP2_PHA     ]                       + voice->mods[MOD_OP2_PHA      ];
   float modop1_det      = shared->params[PARAM_OP1_DET     ]                       + voice->mods[MOD_OP1_DET      ];
   float modop2_det      = shared->params[PARAM_OP2_DET     ]                       + voice->mods[MOD_OP2_DET      ];
   float modop2_ratio    = shared->params[PARAM_OP2_RATIO   ]                       + voice->mods[MOD_OP2_RATIO    ];
   float modop2_level    = shared->params[PARAM_OP2_LEVEL   ]                       + voice->mods[MOD_OP2_LEVEL    ];

   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;
      voice->mod_op1_mix_inc      = (modop1_mix         - voice->mod_op1_mix_cur       ) * recBlockSize;
      voice->mod_op2_mix_inc      = (modop2_mix         - voice->mod_op2_mix_cur       ) * recBlockSize;
      voice->mod_op1_pha_inc      = (modop1_pha         - voice->mod_op1_pha_cur       ) * recBlockSize;
      voice->mod_op2_pha_inc      = (modop2_pha         - voice->mod_op2_pha_cur       ) * recBlockSize;
      voice->mod_op1_det_inc      = (modop1_det         - voice->mod_op1_det_cur       ) * recBlockSize;
      voice->mod_op2_det_inc      = (modop2_det         - voice->mod_op2_det_cur       ) * recBlockSize;
      voice->mod_op2_ratio_inc    = (modop2_ratio       - voice->mod_op2_ratio_cur     ) * recBlockSize;
      voice->mod_op2_level_inc    = (modop2_level       - voice->mod_op2_level_cur     ) * recBlockSize;

      loc_prepare(&voice->base);
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;
      voice->mod_op1_mix_cur      = modop1_mix;
      voice->mod_op1_mix_inc      = 0.0f;
      voice->mod_op2_mix_cur      = modop2_mix;
      voice->mod_op2_mix_inc      = 0.0f;
      voice->mod_op1_pha_cur      = modop1_pha;
      voice->mod_op1_pha_inc      = 0.0f;
      voice->mod_op2_pha_cur      = modop2_pha;
      voice->mod_op2_pha_inc      = 0.0f;
      voice->mod_op1_det_cur      = modop1_det;
      voice->mod_op1_det_inc      = 0.0f;
      voice->mod_op2_det_cur      = modop2_det;
      voice->mod_op2_det_inc      = 0.0f;
      voice->mod_op2_ratio_cur    = modop2_ratio;
      voice->mod_op2_ratio_inc    = 0.0f;
      voice->mod_op2_level_cur    = modop2_level;
      voice->mod_op2_level_inc    = 0.0f;

      loc_prepare(&voice->base);
   }

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm2s_macro_shared_t);

   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
         float tmp_f;
         float tmp2_f;
         
         // ========
         // ======== lane "out" modIdx=0
         // ========
         
         // -- mod="$m_op2_level" dstVar=out
         out = voice->mod_op2_level_cur;
         
         // -- mod="16" dstVar=out
         voice->tmp33_seq = 16.0f;
         out *= voice->tmp33_seq;
         
         // -- mod="sto v_level_2" dstVar=out
         voice->var_v_level_2 = out;
         
         // -- mod="sin" dstVar=out
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="$v_freq_2_sin" dstVar=voice->tmp36_freq
         voice->tmp36_freq = voice->var_v_freq_2_sin;
         voice->tmp35_sin_speed = voice->note_speed_cur * voice->tmp36_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="osc_pha_2.sin" dstVar=voice->tmp38_phase
         voice->tmp38_phase = voice->macrovar_osc_pha_2_sin;
         voice->tmp37_sin_tmp = ((voice->tmp34_sin_phase + voice->tmp38_phase));
         voice->tmp37_sin_tmp = ffrac_s(voice->tmp37_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp37_sin_tmp)&16383u];
         voice->tmp34_sin_phase = ffrac_s(voice->tmp34_sin_phase + voice->tmp35_sin_speed);
         
         // -- mod="osc_mix_2.sin" dstVar=out
         voice->tmp39_seq = voice->macrovar_osc_mix_2_sin;
         out *= voice->tmp39_seq;
         
         // -- mod="tri" dstVar=out
         
         // ---- mod="tri" input "freq" seq 1/1
         
         // -- mod="$v_freq_2_tri" dstVar=voice->tmp43_freq
         voice->tmp43_freq = voice->var_v_freq_2_tri;
         voice->tmp42_tri_speed = voice->note_speed_cur * voice->tmp43_freq;
         
         // ---- mod="tri" input "phase" seq 1/1
         
         // -- mod="osc_pha_2.tri" dstVar=voice->tmp45_phase
         voice->tmp45_phase = voice->macrovar_osc_pha_2_tri;
         voice->tmp44_tri_tmp = ((voice->tmp41_tri_phase + voice->tmp45_phase));
         voice->tmp44_tri_tmp = ffrac_s(voice->tmp44_tri_tmp);
         voice->tmp40_seq = (voice->tmp44_tri_tmp < 0.5f) ? (-1.0 + voice->tmp44_tri_tmp * 4.0f) : (1.0 - (voice->tmp44_tri_tmp - 0.5f)*4);
         voice->tmp41_tri_phase = ffrac_s(voice->tmp41_tri_phase + voice->tmp42_tri_speed);
         
         // -- mod="osc_mix_2.tri" dstVar=voice->tmp40_seq
         voice->tmp46_seq = voice->macrovar_osc_mix_2_tri;
         voice->tmp40_seq *= voice->tmp46_seq;
         out += voice->tmp40_seq;
         
         // -- mod="pul" dstVar=out
         
         // ---- mod="pul" input "freq" seq 1/1
         
         // -- mod="$v_freq_2_pul" dstVar=voice->tmp50_freq
         voice->tmp50_freq = voice->var_v_freq_2_pul;
         voice->tmp49_pul_speed = voice->note_speed_cur * voice->tmp50_freq;
         
         // ---- mod="pul" input "phase" seq 1/1
         
         // -- mod="osc_pha_2.pul" dstVar=voice->tmp52_phase
         voice->tmp52_phase = voice->macrovar_osc_pha_2_pul;
         
         // ---- mod="pul" input "width" seq 1/1
         
         // -- mod="osc_pha_2.pul" dstVar=voice->tmp53_width
         voice->tmp53_width = voice->macrovar_osc_pha_2_pul;
         voice->tmp51_pul_tmp = ((voice->tmp48_pul_phase + voice->tmp52_phase));
         voice->tmp51_pul_tmp = ffrac_s(voice->tmp51_pul_tmp);
         voice->tmp47_seq = (voice->tmp51_pul_tmp >= voice->tmp53_width) ? 1.0f : -1.0f;
         voice->tmp48_pul_phase = ffrac_s(voice->tmp48_pul_phase + voice->tmp49_pul_speed);
         
         // -- mod="osc_mix_2.pul" dstVar=voice->tmp47_seq
         voice->tmp54_seq = voice->macrovar_osc_mix_2_pul;
         voice->tmp47_seq *= voice->tmp54_seq;
         out += voice->tmp47_seq;
         
         // -- mod="saw" dstVar=out
         
         // ---- mod="saw" input "freq" seq 1/1
         
         // -- mod="$v_freq_2_saw" dstVar=voice->tmp58_freq
         voice->tmp58_freq = voice->var_v_freq_2_saw;
         voice->tmp57_saw_speed = voice->note_speed_cur * voice->tmp58_freq;
         
         // ---- mod="saw" input "phase" seq 1/1
         
         // -- mod="osc_pha_2.saw" dstVar=voice->tmp60_phase
         voice->tmp60_phase = voice->macrovar_osc_pha_2_saw;
         voice->tmp59_saw_tmp = ((voice->tmp56_saw_phase + voice->tmp60_phase));
         voice->tmp59_saw_tmp = ffrac_s(voice->tmp59_saw_tmp);
         voice->tmp55_seq = 1.0 - (voice->tmp59_saw_tmp * 2.0f);
         voice->tmp56_saw_phase = ffrac_s(voice->tmp56_saw_phase + voice->tmp57_saw_speed);
         
         // -- mod="osc_mix_2.saw" dstVar=voice->tmp55_seq
         voice->tmp61_seq = voice->macrovar_osc_mix_2_saw;
         voice->tmp55_seq *= voice->tmp61_seq;
         out += voice->tmp55_seq;
         
         // -- mod="$v_level_2" dstVar=out
         voice->tmp62_seq = voice->var_v_level_2;
         out *= voice->tmp62_seq;
         
         // -- mod="sto v_osc_2" dstVar=out
         voice->var_v_osc_2 = out;
         
         // -- mod="sin" dstVar=out
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="$v_freq_1_sin" dstVar=voice->tmp65_freq
         voice->tmp65_freq = voice->var_v_freq_1_sin;
         voice->tmp64_sin_speed = voice->note_speed_cur * voice->tmp65_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_osc_2" dstVar=voice->tmp67_phase
         voice->tmp67_phase = voice->var_v_osc_2;
         
         // -- mod="osc_pha_1.sin" dstVar=voice->tmp67_phase
         voice->tmp68_seq = voice->macrovar_osc_pha_1_sin;
         voice->tmp67_phase += voice->tmp68_seq;
         voice->tmp66_sin_tmp = ((voice->tmp63_sin_phase + voice->tmp67_phase));
         voice->tmp66_sin_tmp = ffrac_s(voice->tmp66_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp66_sin_tmp)&16383u];
         voice->tmp63_sin_phase = ffrac_s(voice->tmp63_sin_phase + voice->tmp64_sin_speed);
         
         // -- mod="osc_mix_1.sin" dstVar=out
         voice->tmp69_seq = voice->macrovar_osc_mix_1_sin;
         out *= voice->tmp69_seq;
         
         // -- mod="tri" dstVar=out
         
         // ---- mod="tri" input "freq" seq 1/1
         
         // -- mod="$v_freq_1_tri" dstVar=voice->tmp73_freq
         voice->tmp73_freq = voice->var_v_freq_1_tri;
         voice->tmp72_tri_speed = voice->note_speed_cur * voice->tmp73_freq;
         
         // ---- mod="tri" input "phase" seq 1/1
         
         // -- mod="$v_osc_2" dstVar=voice->tmp75_phase
         voice->tmp75_phase = voice->var_v_osc_2;
         
         // -- mod="osc_pha_1.tri" dstVar=voice->tmp75_phase
         voice->tmp76_seq = voice->macrovar_osc_pha_1_tri;
         voice->tmp75_phase += voice->tmp76_seq;
         voice->tmp74_tri_tmp = ((voice->tmp71_tri_phase + voice->tmp75_phase));
         voice->tmp74_tri_tmp = ffrac_s(voice->tmp74_tri_tmp);
         voice->tmp70_seq = (voice->tmp74_tri_tmp < 0.5f) ? (-1.0 + voice->tmp74_tri_tmp * 4.0f) : (1.0 - (voice->tmp74_tri_tmp - 0.5f)*4);
         voice->tmp71_tri_phase = ffrac_s(voice->tmp71_tri_phase + voice->tmp72_tri_speed);
         
         // -- mod="osc_mix_1.tri" dstVar=voice->tmp70_seq
         voice->tmp77_seq = voice->macrovar_osc_mix_1_tri;
         voice->tmp70_seq *= voice->tmp77_seq;
         out += voice->tmp70_seq;
         
         // -- mod="pul" dstVar=out
         
         // ---- mod="pul" input "freq" seq 1/1
         
         // -- mod="$v_freq_1_pul" dstVar=voice->tmp81_freq
         voice->tmp81_freq = voice->var_v_freq_1_pul;
         voice->tmp80_pul_speed = voice->note_speed_cur * voice->tmp81_freq;
         
         // ---- mod="pul" input "phase" seq 1/1
         
         // -- mod="$v_osc_2" dstVar=voice->tmp83_phase
         voice->tmp83_phase = voice->var_v_osc_2;
         
         // -- mod="osc_pha_1.pul" dstVar=voice->tmp83_phase
         voice->tmp84_seq = voice->macrovar_osc_pha_1_pul;
         voice->tmp83_phase += voice->tmp84_seq;
         
         // ---- mod="pul" input "width" seq 1/1
         
         // -- mod="osc_pha_1.pul" dstVar=voice->tmp85_width
         voice->tmp85_width = voice->macrovar_osc_pha_1_pul;
         voice->tmp82_pul_tmp = ((voice->tmp79_pul_phase + voice->tmp83_phase));
         voice->tmp82_pul_tmp = ffrac_s(voice->tmp82_pul_tmp);
         voice->tmp78_seq = (voice->tmp82_pul_tmp >= voice->tmp85_width) ? 1.0f : -1.0f;
         voice->tmp79_pul_phase = ffrac_s(voice->tmp79_pul_phase + voice->tmp80_pul_speed);
         
         // -- mod="osc_mix_1.pul" dstVar=voice->tmp78_seq
         voice->tmp86_seq = voice->macrovar_osc_mix_1_pul;
         voice->tmp78_seq *= voice->tmp86_seq;
         out += voice->tmp78_seq;
         
         // -- mod="saw" dstVar=out
         
         // ---- mod="saw" input "freq" seq 1/1
         
         // -- mod="$v_freq_1_saw" dstVar=voice->tmp90_freq
         voice->tmp90_freq = voice->var_v_freq_1_saw;
         voice->tmp89_saw_speed = voice->note_speed_cur * voice->tmp90_freq;
         
         // ---- mod="saw" input "phase" seq 1/1
         
         // -- mod="$v_osc_2" dstVar=voice->tmp92_phase
         voice->tmp92_phase = voice->var_v_osc_2;
         
         // -- mod="osc_pha_1.saw" dstVar=voice->tmp92_phase
         voice->tmp93_seq = voice->macrovar_osc_pha_1_saw;
         voice->tmp92_phase += voice->tmp93_seq;
         voice->tmp91_saw_tmp = ((voice->tmp88_saw_phase + voice->tmp92_phase));
         voice->tmp91_saw_tmp = ffrac_s(voice->tmp91_saw_tmp);
         voice->tmp87_seq = 1.0 - (voice->tmp91_saw_tmp * 2.0f);
         voice->tmp88_saw_phase = ffrac_s(voice->tmp88_saw_phase + voice->tmp89_saw_speed);
         
         // -- mod="osc_mix_1.saw" dstVar=voice->tmp87_seq
         voice->tmp94_seq = voice->macrovar_osc_mix_1_saw;
         voice->tmp87_seq *= voice->tmp94_seq;
         out += voice->tmp87_seq;
   
         /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
      voice->mod_op1_mix_cur       += voice->mod_op1_mix_inc;
      voice->mod_op2_mix_cur       += voice->mod_op2_mix_inc;
      voice->mod_op1_pha_cur       += voice->mod_op1_pha_inc;
      voice->mod_op2_pha_cur       += voice->mod_op2_pha_inc;
      voice->mod_op1_det_cur       += voice->mod_op1_det_inc;
      voice->mod_op2_det_cur       += voice->mod_op2_det_inc;
      voice->mod_op2_ratio_cur     += voice->mod_op2_ratio_inc;
      voice->mod_op2_level_cur     += voice->mod_op2_level_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   osc_fm2s_macro_shared_t *ret = (osc_fm2s_macro_shared_t *)malloc(sizeof(osc_fm2s_macro_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   osc_fm2s_macro_voice_t *voice = (osc_fm2s_macro_voice_t *)malloc(sizeof(osc_fm2s_macro_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(osc_fm2s_macro_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *osc_fm2s_macro_init(void) {
   osc_fm2s_macro_info_t *ret = (osc_fm2s_macro_info_t *)malloc(sizeof(osc_fm2s_macro_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "osc_fm2s_macro";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "fm2s macro osc";
      ret->base.short_name  = "fm2s macro osc";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new       = &loc_shared_new;
      ret->base.shared_delete    = &loc_shared_delete;
      ret->base.voice_new        = &loc_voice_new;
      ret->base.voice_delete     = &loc_voice_delete;
      ret->base.get_param_name   = &loc_get_param_name;
      ret->base.get_param_reset  = &loc_get_param_reset;
      ret->base.get_param_value  = &loc_get_param_value;
      ret->base.set_param_value  = &loc_set_param_value;
      ret->base.get_mod_name     = &loc_get_mod_name;
      ret->base.set_sample_rate  = &loc_set_sample_rate;
      ret->base.note_on          = &loc_note_on;
      ret->base.set_mod_value    = &loc_set_mod_value;
      ret->base.prepare_block    = &loc_prepare_block;
      ret->base.process_replace  = &loc_process_replace;
      ret->base.plugin_exit      = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return osc_fm2s_macro_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
