// ----
// ---- file   : x_osc_true_fm3p.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c x_osc_true_fm3p.cpp -o x_osc_true_fm3p.o
// ---- created: 11Nov2023 19:16:41
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>


#define OVERSAMPLE_FACTOR  16.0f

#define PARAM_PHASE_2            0
#define PARAM_PHASE_RAND         1
#define PARAM_RATIO_2            2
#define PARAM_VOICEBUS           3
#define PARAM_LEVEL_2            4
#define PARAM_LEVEL_3            5
#define NUM_PARAMS               6
static const char *loc_param_names[NUM_PARAMS] = {
   "phase_2",                 // 0: PHASE_2
   "phase_rand",              // 1: PHASE_RAND
   "ratio_2",                 // 2: RATIO_2
   "voicebus",                // 3: VOICEBUS
   "level_2",                 // 4: LEVEL_2
   "level_3",                 // 5: LEVEL_3

};
static float loc_param_resets[NUM_PARAMS] = {
   0.0f,                      // 0: PHASE_2
   0.0f,                      // 1: PHASE_RAND
   0.5f,                      // 2: RATIO_2
   0.1f,                      // 3: VOICEBUS
   0.0f,                      // 4: LEVEL_2
   0.0f,                      // 5: LEVEL_3

};

#define MOD_PHASE_2              0
#define MOD_RATIO_2              1
#define MOD_VOICEBUS             2
#define MOD_LEVEL_2              3
#define MOD_LEVEL_3              4
#define NUM_MODS                 5
static const char *loc_mod_names[NUM_MODS] = {
   "phase_2",      // 0: PHASE_2
   "ratio_2",      // 1: RATIO_2
   "voicebus",     // 2: VOICEBUS
   "level_2",      // 3: LEVEL_2
   "level_3",      // 4: LEVEL_3

};

typedef struct x_osc_true_fm3p_info_s {
   st_plugin_info_t base;
} x_osc_true_fm3p_info_t;

typedef struct x_osc_true_fm3p_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} x_osc_true_fm3p_shared_t;

typedef struct x_osc_true_fm3p_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];
   float mod_phase_2_cur;
   float mod_phase_2_inc;
   float mod_ratio_2_cur;
   float mod_ratio_2_inc;
   float mod_voicebus_cur;
   float mod_voicebus_inc;
   float mod_level_2_cur;
   float mod_level_2_inc;
   float mod_level_3_cur;
   float mod_level_3_inc;

   short tmp1_i2f;
   unsigned short tmp2_lfsr_state;
   short tmp3_lfsr_state_signed;
   float tmp4_seq;
   short tmp5_i2f;
   unsigned short tmp6_lfsr_state;
   short tmp7_lfsr_state_signed;
   float tmp8_seq;
   float tmp9_sin_phase;
   float tmp10_sin_speed;
   float tmp11_freq;
   float tmp12_sin_phase;
   float tmp13_sin_speed;
   float tmp14_freq;
   float tmp15_sin_tmp;
   float tmp16_phase;
   float tmp17_seq;
   float tmp18_seq;
   float tmp19_seq;
   float tmp20_sin_tmp;
   float tmp21_phase;
   float tmp22_seq;
   float tmp23_seq;
   float tmp24_nrf;
   unsigned int voicebus_idx_0;
   float tmp25_seq;
   float tmp26_seq;
   float var_x;
   float var_v_phrand_1;
   float var_v_phrand_2;
   float var_v_freq_2;

} x_osc_true_fm3p_voice_t;

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }

#define USE_CYCLE_SINE_TBL  defined
static float cycle_sine_tbl_f[16384];

static float loc_bipolar_to_scale(const float _t, const float _div, const float _mul) {
   // t (-1..1) => /_div .. *_mul
   
   float s;

   if(_t < 0.0f)
   {
      s = (1.0f / _div);
      s = 1.0f + (s - 1.0f) * -_t;
      if(s < 0.0f)
         s = 0.0f;
   }
   else
   {
      s = _mul;
      s = 1.0f + (s - 1.0f) * _t;
   }
   
   return s;
}

static void loc_init(st_plugin_voice_t *_voice);
static void loc_prepare(st_plugin_voice_t *_voice);

void loc_init(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(x_osc_true_fm3p_shared_t);

   float out = 0.0f;
   // -------- lane "init" modIdx=0
   
   // -- mod="fsr" dstVar=out
   voice->tmp1_i2f = (int)(out * 2048);  // IntFallback: F2I
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state >> 7;
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state << 9;
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state >> 13;
   voice->tmp3_lfsr_state_signed = (voice->tmp2_lfsr_state & 65520);
   voice->tmp1_i2f = voice->tmp3_lfsr_state_signed >> 4;
   out = voice->tmp1_i2f / ((float)(2048));  // IntFallback: I2F
   
   // -- mod="$p_phase_rand" dstVar=out
   voice->tmp4_seq = shared->params[PARAM_PHASE_RAND];
   out *= voice->tmp4_seq;
   
   // -- mod="sto v_phrand_1" dstVar=out
   voice->var_v_phrand_1 = out;
   
   // -- mod="fsr" dstVar=out
   voice->tmp5_i2f = (int)(out * 2048);  // IntFallback: F2I
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state >> 7;
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state << 9;
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state >> 13;
   voice->tmp7_lfsr_state_signed = (voice->tmp6_lfsr_state & 65520);
   voice->tmp5_i2f = voice->tmp7_lfsr_state_signed >> 4;
   out = voice->tmp5_i2f / ((float)(2048));  // IntFallback: I2F
   
   // -- mod="$p_phase_rand" dstVar=out
   voice->tmp8_seq = shared->params[PARAM_PHASE_RAND];
   out *= voice->tmp8_seq;
   
   // -- mod="sto v_phrand_2" dstVar=out
   voice->var_v_phrand_2 = out;
} /* end init */

void loc_prepare(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(x_osc_true_fm3p_shared_t);

   float out = 0.0f;
   // -------- lane "prepare" modIdx=0
   
   // -- mod="$m_ratio_2" dstVar=out
   out = voice->mod_ratio_2_cur;
   
   // -- mod="fma" dstVar=out
   out = (out * 2.0f) + -1.0f;
   
   // -- mod="bts" dstVar=out
   out = loc_bipolar_to_scale(out, 4096.0f, 4.0f);
   
   // -- mod="pow" dstVar=out
   out = out * out * out;
   
   // -- mod="qua" dstVar=out
   out = ((int)(out * 100.0f) / 100.0f);
   
   // -- mod="sto v_freq_2" dstVar=out
   voice->var_v_freq_2 = out;
} /* end prepare */

static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(x_osc_true_fm3p_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(x_osc_true_fm3p_shared_t);
   shared->params[_paramIdx] = _value;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(x_osc_true_fm3p_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR


      voice->tmp3_lfsr_state_signed = 0;
      voice->tmp7_lfsr_state_signed = 0;
      voice->tmp9_sin_phase = 0.0f;
      voice->tmp12_sin_phase = 0.0f;

      voice->var_x = 0.0f;
      voice->var_v_phrand_1 = 0.0f;
      voice->var_v_phrand_2 = 0.0f;
      voice->var_v_freq_2 = 0.0f;

      loc_init(&voice->base);

   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(x_osc_true_fm3p_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR

   float modphase_2      = shared->params[PARAM_PHASE_2     ]                       + voice->mods[MOD_PHASE_2      ];
   float modratio_2      = shared->params[PARAM_RATIO_2     ]                       + voice->mods[MOD_RATIO_2      ];
   float modvoicebus     = shared->params[PARAM_VOICEBUS    ]                       + voice->mods[MOD_VOICEBUS     ];
   float modlevel_2      = shared->params[PARAM_LEVEL_2     ]                       + voice->mods[MOD_LEVEL_2      ];
   float modlevel_3      = shared->params[PARAM_LEVEL_3     ]                       + voice->mods[MOD_LEVEL_3      ];

   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;
      voice->mod_phase_2_inc      = (modphase_2         - voice->mod_phase_2_cur       ) * recBlockSize;
      voice->mod_ratio_2_inc      = (modratio_2         - voice->mod_ratio_2_cur       ) * recBlockSize;
      voice->mod_voicebus_inc     = (modvoicebus        - voice->mod_voicebus_cur      ) * recBlockSize;
      voice->mod_level_2_inc      = (modlevel_2         - voice->mod_level_2_cur       ) * recBlockSize;
      voice->mod_level_3_inc      = (modlevel_3         - voice->mod_level_3_cur       ) * recBlockSize;

      loc_prepare(&voice->base);
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;
      voice->mod_phase_2_cur      = modphase_2;
      voice->mod_phase_2_inc      = 0.0f;
      voice->mod_ratio_2_cur      = modratio_2;
      voice->mod_ratio_2_inc      = 0.0f;
      voice->mod_voicebus_cur     = modvoicebus;
      voice->mod_voicebus_inc     = 0.0f;
      voice->mod_level_2_cur      = modlevel_2;
      voice->mod_level_2_inc      = 0.0f;
      voice->mod_level_3_cur      = modlevel_3;
      voice->mod_level_3_inc      = 0.0f;

      loc_prepare(&voice->base);
   }

// ---- mod="bus" input "nr" seq 1/1

// -- mod="$m_voicebus" dstVar=voice->tmp24_nrf
voice->tmp24_nrf = voice->mod_voicebus_cur;
   Dstplugin_voicebus(voice->voicebus_idx_0, voice->tmp24_nrf);

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(x_osc_true_fm3p_shared_t);

   const float *samplesBus0 = voice->base.voice_bus_buffers[voice->voicebus_idx_0] + voice->base.voice_bus_read_offset;
   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
         float tmp_f;
         float tmp2_f;
         
         // ========
         // ======== lane "out" modIdx=0
         // ========
         
         // -- mod="sin" dstVar=out
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="sin" dstVar=voice->tmp11_freq
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="$v_freq_2" dstVar=voice->tmp14_freq
         voice->tmp14_freq = voice->var_v_freq_2;
         voice->tmp13_sin_speed = voice->note_speed_cur * voice->tmp14_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_phrand_2" dstVar=voice->tmp16_phase
         voice->tmp16_phase = voice->var_v_phrand_2;
         
         // -- mod="$m_phase_2" dstVar=voice->tmp16_phase
         voice->tmp17_seq = voice->mod_phase_2_cur;
         voice->tmp16_phase += voice->tmp17_seq;
         voice->tmp15_sin_tmp = ((voice->tmp12_sin_phase + voice->tmp16_phase));
         voice->tmp15_sin_tmp = ffrac_s(voice->tmp15_sin_tmp);
         voice->tmp11_freq = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp15_sin_tmp)&16383u];
         voice->tmp12_sin_phase = ffrac_s(voice->tmp12_sin_phase + voice->tmp13_sin_speed);
         
         // -- mod="$m_level_2" dstVar=voice->tmp11_freq
         voice->tmp18_seq = voice->mod_level_2_cur;
         
         // -- mod="2" dstVar=voice->tmp18_seq
         voice->tmp19_seq = 2.0f;
         voice->tmp18_seq *= voice->tmp19_seq;
         
         // -- mod="pow" dstVar=voice->tmp18_seq
         voice->tmp18_seq = voice->tmp18_seq * voice->tmp18_seq;
         voice->tmp11_freq *= voice->tmp18_seq;
         
         // -- mod="bts" dstVar=voice->tmp11_freq
         voice->tmp11_freq = loc_bipolar_to_scale(voice->tmp11_freq, 32.0f, 32.0f);
         voice->tmp10_sin_speed = voice->note_speed_cur * voice->tmp11_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_phrand_1" dstVar=voice->tmp21_phase
         voice->tmp22_seq = voice->var_v_phrand_1;
         voice->tmp21_phase += voice->tmp22_seq;
         
         // -- mod="bus" dstVar=voice->tmp21_phase
         voice->tmp23_seq = samplesBus0[k];
         
         // -- mod="$m_level_3" dstVar=voice->tmp23_seq
         voice->tmp25_seq = voice->mod_level_3_cur;
         
         // -- mod="2" dstVar=voice->tmp25_seq
         voice->tmp26_seq = 2.0f;
         voice->tmp25_seq *= voice->tmp26_seq;
         
         // -- mod="pow" dstVar=voice->tmp25_seq
         voice->tmp25_seq = voice->tmp25_seq * voice->tmp25_seq;
         voice->tmp23_seq *= voice->tmp25_seq;
         voice->tmp21_phase += voice->tmp23_seq;
         voice->tmp20_sin_tmp = ((voice->tmp9_sin_phase + voice->tmp21_phase));
         voice->tmp20_sin_tmp = ffrac_s(voice->tmp20_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp20_sin_tmp)&16383u];
         voice->tmp9_sin_phase = ffrac_s(voice->tmp9_sin_phase + voice->tmp10_sin_speed);
   
         /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
      voice->mod_phase_2_cur       += voice->mod_phase_2_inc;
      voice->mod_ratio_2_cur       += voice->mod_ratio_2_inc;
      voice->mod_voicebus_cur      += voice->mod_voicebus_inc;
      voice->mod_level_2_cur       += voice->mod_level_2_inc;
      voice->mod_level_3_cur       += voice->mod_level_3_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   x_osc_true_fm3p_shared_t *ret = (x_osc_true_fm3p_shared_t *)malloc(sizeof(x_osc_true_fm3p_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   x_osc_true_fm3p_voice_t *voice = (x_osc_true_fm3p_voice_t *)malloc(sizeof(x_osc_true_fm3p_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
      voice->tmp2_lfsr_state = 16999;
      voice->tmp6_lfsr_state = 43981;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(x_osc_true_fm3p_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *x_osc_true_fm3p_init(void) {
   x_osc_true_fm3p_info_t *ret = (x_osc_true_fm3p_info_t *)malloc(sizeof(x_osc_true_fm3p_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "x_osc_true_fm3p";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "x true fm3p osc";
      ret->base.short_name  = "x true fm3p osc";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC | ST_PLUGIN_FLAG_XMOD;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new       = &loc_shared_new;
      ret->base.shared_delete    = &loc_shared_delete;
      ret->base.voice_new        = &loc_voice_new;
      ret->base.voice_delete     = &loc_voice_delete;
      ret->base.get_param_name   = &loc_get_param_name;
      ret->base.get_param_reset  = &loc_get_param_reset;
      ret->base.get_param_value  = &loc_get_param_value;
      ret->base.set_param_value  = &loc_set_param_value;
      ret->base.get_mod_name     = &loc_get_mod_name;
      ret->base.set_sample_rate  = &loc_set_sample_rate;
      ret->base.note_on          = &loc_note_on;
      ret->base.set_mod_value    = &loc_set_mod_value;
      ret->base.prepare_block    = &loc_prepare_block;
      ret->base.process_replace  = &loc_process_replace;
      ret->base.plugin_exit      = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return x_osc_true_fm3p_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
